#ifndef __I802CS_H_
#define __I802CS_H_ 1


typedef NEOERR* (*I8VARLOOKUPHANLDER)(unsigned char *str, unsigned char **ret);

/*
 * Function: i802cs_register_lookup_handler - register a lookup failure handling function
 * Description: i802cs_register_lookup_handler will register a function that
 *              can be called during CS render.  If a variable lookup fails, the registered
 * 		function will be invoked with the lookup string as well as an optional
 * 		result parameter.  The previously registered handler will be replaced.
 *              This function should not modify the input string, and 
 *              should allocate the output string with a libc function.
 *              (as we will call free on it)
 * Input: handler - a I8VARLOOKUPHANLDER callback
 *          
 */
NEOERR *i802cs_register_lookup_handler(I8VARLOOKUPHANLDER handler);

#endif /* __I802CS_H_ */
