//
// de.gyronet.kangaroo.io.FileConnection.c
// kangaroo
//
// Created by Marc Kleine-Budde on 03.28.2003
// Copyright (c) 2003 GYRO net GmbH. All rights reserved.
//
// inspired by / copied from: java.io.File.c
// from the Kaffe Project
//
// see original Copyright below... 

/*
 * java.io.File.c
 *
 * Copyright (c) 1996, 1997, 1998, 1999
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include "config-io.h"
#include "config-mem.h"
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <native.h>
#include <jsyscall.h>
#ifdef HAVE_UTIME_H
#include <utime.h>
#endif
#include "defs.h"
#include "files.h"
#include "../../../include/system.h"
#include "../../../kaffe/kaffevm/support.h"
#include "../../../kaffe/kaffevm/stringSupport.h"
#include "javax_microedition_io_Connector.h"
#include "de_gyronet_kangaroo_io_FileConnection.h"

/*
 * Is named item a directory?
 */
jboolean
de_gyronet_kangaroo_io_FileConnection_isDirectory
(struct Hjava_lang_String* path)
{
	struct stat buf;
	char str[MAXPATHLEN];
	int r;

	stringJava2CBuf(path, str, sizeof(str));

	r = KSTAT(str, &buf);
	if (r == 0 && S_ISDIR(buf.st_mode)) {
		return (1);
	}
	else {
		return (0);
	}
}


jint
de_gyronet_kangaroo_io_FileConnection_open0
(struct Hde_gyronet_kangaroo_io_FileConnection* this,
 struct Hjava_lang_String* name, jint mode)
{
	char str[MAXPATHLEN];
	int fd;
	int rc;
	int flags = 0;

	
	stringJava2CBuf(name, str, sizeof(str));

	switch (mode) {
	case javax_microedition_io_Connector_READ:
		flags = O_BINARY|O_RDONLY;
		break;
	case javax_microedition_io_Connector_WRITE:
		// FIXME: kangaroo: make difference between append and truncate mode

		flags = O_BINARY|O_WRONLY|O_CREAT|O_TRUNC;
		//flags = O_BINARY|O_WRONLY|O_CREAT|O_APPEND
		break;
	case javax_microedition_io_Connector_READ_WRITE:
		flags = O_BINARY|O_RDWR|O_CREAT;
		break;
	}

	rc = KOPEN(str, flags, 0, &fd);
	if (rc) {
		SignalError("java.io.IOException", SYS_ERROR(rc));
	}

	return fd;
}
