#include <jni.h>
#include "i802.h"
#include <stdio.h>
#include <openssl/md5.h>
#include <openssl/md4.h>
#include <openssl/hmac.h>

JNIEXPORT 
void
	Java_com_instant802_cldc_ssl_OpenSSL_md5(JNIEnv *env, jobject ob,
	                   jbyteArray jtext, jint textlen, jbyteArray hash) {
	// (byte[] text, int textlen, byte[] hash)
		unsigned char md[16];
		char *text;

		text = malloc(textlen);
		// Need to throw errors in various places ... todo
		(*env)->GetByteArrayRegion(env,  jtext, 0, textlen, text);

		MD5(text, textlen, md);	
		
		(*env)->SetByteArrayRegion(env, hash, 0, 16, md); 

		free(text);
	}

JNIEXPORT
void
	Java_com_instant802_cldc_ssl_OpenSSL_md4(JNIEnv *env, jobject ob,
	                   jbyteArray jtext, jint textlen, jbyteArray hash) {
	// (byte[] text, int textlen, byte[] hash)
		unsigned char md[16];
		char *text;

		text = malloc(textlen);
		// Need to throw errors in various places ... todo
		(*env)->GetByteArrayRegion(env,  jtext, 0, textlen, text);

		MD4(text, textlen, md);	
		
		(*env)->SetByteArrayRegion(env, hash, 0, 16, md); 

		free(text);
	}
	
JNIEXPORT
void
	// (byte[] key, int keylen, byte[]data, int datalen, byte[16] hash) 
	Java_com_instant802_cldc_ssl_OpenSSL_hmacmd5(JNIEnv *env, jobject ob,
	 	jbyteArray jkey, jint keylen,  jbyteArray jdata, jint datalen, jbyteArray hash) {
		char  *key, *data;
		unsigned char md[16];
		int mdlen = 16;
		key = malloc(keylen);
		data = malloc(datalen);
		(*env)->GetByteArrayRegion(env, jkey, 0, keylen, key);
		(*env)->GetByteArrayRegion(env, jdata, 0, datalen, data);		
		HMAC(EVP_md5(), key, keylen, data, datalen, md, &mdlen);	
		(*env)->SetByteArrayRegion(env, hash, 0, 16, md); 
		free(key);
		free(data);
	}

