//
// de.gyronet.kangaroo.io.ConsoleConnection.java
// kangaroo
//
// Created by Volker Gies on Thu Jul 18 2002.
// Copyright (c) 2002,2003 GYRO net GmbH. All rights reserved.
//

package de.gyronet.kangaroo.io;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.util.Hashtable;
import javax.microedition.io.Connection;
import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;

/**
 * @version $Id: ConsoleConnection.java,v 1.1.1.1 2003/10/31 00:47:08 carter Exp $
 * @author Volker Gies
 *
 */
public class ConsoleConnection implements Protocol, StreamConnection {

    ConsoleImpl in;
    ConsoleImpl out;

    public Connection open(String target, Hashtable params, int mode, boolean timeouts) throws IOException {
	in = new ConsoleImpl(0);
	out = new ConsoleImpl(1);

	in.mode = (mode & Connector.READ);
	in.open = true;
	in.openCounter++;

	out.mode = (mode & Connector.WRITE);
	out.open = true;
	out.openCounter++;

	return this;
    }

            
    public void close() throws IOException {
	in.close();
	out.close();
    }
    
    public InputStream openInputStream() throws IOException {
        return in.openInputStream();
    }
    
    public DataInputStream openDataInputStream() throws IOException {
        return in.openDataInputStream();
    }

    public OutputStream openOutputStream() throws IOException {
        return out.openOutputStream();
    }
    
    public DataOutputStream openDataOutputStream() throws IOException {
        return out.openDataOutputStream();
    }
}
