//
// de.gyronet.kangaroo.io.StreamReader.java
// kangaroo
//
// Created by Volker Gies on Thu Jul 18 2002.
// Copyright (c) 2002 GYRO net GmbH. All rights reserved.
//

package de.gyronet.kangaroo.io;

import java.io.Reader;
import java.io.InputStream;
import java.io.IOException;

/**
 * @version $Id: StreamReader.java,v 1.1.1.1 2003/10/31 00:47:08 carter Exp $
 * @author Volker Gies
 *
 */
public abstract class StreamReader extends Reader {
    public InputStream in;

    public Reader open(InputStream in) {
        this.in = in;
        return this;
    }

    public boolean ready() {
        try {
            return in.available() > 0;
        } catch (IOException x) {
            return false;
        }
    }

    public boolean markSupported() {
        return in.markSupported();
    }

    public void mark(int readAheadLimit) throws IOException {
        in.mark(readAheadLimit);
    }

    public void reset() throws IOException {
        in.reset();
    }

    public void close() throws IOException {
        in.close();
    }

    public abstract int sizeOf(byte[] array, int offset, int length);
}
