//
// de.gyronet.kangaroo.io.TCPServerConnection.java
// kangaroo
//
// Created by Marc Kleine-Budde on 04.22.2003
// Copyright (c) 2003 GYRO net GmbH. All rights reserved.
//
// inspired by / copied from: java.net.PlainSocketImpl.java
//			      java.net.ServerSocket.java
// from the Kaffe Project
//
// see original Copyright below... 

/*
 * Java core library component.
 *
 * Copyright (c) 1997, 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

package de.gyronet.kangaroo.io;

import java.io.IOException;
import java.lang.IllegalArgumentException;
import java.util.Hashtable;
import javax.microedition.io.Connection;
import javax.microedition.io.Connector;
import javax.microedition.io.ServerSocketConnection;
import javax.microedition.io.StreamConnection;

public class TCPServerConnection implements ServerSocketConnection {

    InetImpl con;

    int localport;
    int localaddr;
    int mode;

    Connection open(URL targetURL, Hashtable params, int mode, boolean timeouts) throws IOException {
	con = new InetImpl();
	
	int backlog = 50;
	int timeout = timeouts ? 60000 : 0;

	this.localport = targetURL.port;
	this.mode = mode;

	try {
	    con.create0(true);
	    con.bind0(targetURL.addr, localport);	// localaddr == 0 is replaced by INADDR_ANY in native lib
	    con.listen0(backlog);
	} catch (IOException e) {
	    try {
		con.close();
	    } catch (IOException _) {
	    }
	    throw(e);
	}

	return this;
    }


    public StreamConnection acceptAndOpen() throws IOException {
	InetImpl newCon = new InetImpl();

	newCon.mode = mode;
	newCon.localport = localport;
	newCon.localaddr = localaddr;
      
	con.acceptAndOpen0(newCon);

	newCon.open = true;
	newCon.openCounter++;

	return new TCPConnection(newCon);
    }


    public void close() throws IOException {
	con.close();
    }

    public String getLocalAddress() throws IOException {
	return con.getLocalAddress();
    }

    public int getLocalPort() throws IOException {
	return con.getLocalPort();
    }
}
