
#ifndef __LCL_PHY_TX_POWER_H___
#define __LCL_PHY_TX_POWER_H____

#include<stdarg.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include "xmlutils.h"
#include "phy_tx_power.h"

/* columns present in counters tables */
#define PHY_TX_POW_NUM_SUPPORTED_POWER_LEVELS   "num_supported_pow_level"
#define PHY_TX_POW_TX_POWER_LEVEL_1             "tx-power"
#define PHY_TX_POW_TX_POWER_LEVEL_2             "tx-power"
#define PHY_TX_POW_TX_POWER_LEVEL_3             "tx-power"
#define PHY_TX_POW_TX_POWER_LEVEL_4             "tx-power"
#define PHY_TX_POW_TX_POWER_LEVEL_5             "tx-power"
#define PHY_TX_POW_TX_POWER_LEVEL_6             "tx-power"
#define PHY_TX_POW_TX_POWER_LEVEL_7             "tx-power"
#define PHY_TX_POW_TX_POWER_LEVEL_8             "tx-power"
#define PHY_TX_POW_CURRENT_TX_POWER_LEVEL       "curr_tx_power_level"

struct phy_tx_data_info{
	char * num_supp_power_levels;
	int num_supp_power_levels_len;
	char *phy_tx_pow_lev1;
	int phy_tx_pow_lev1_len;
	char *phy_tx_pow_lev2;
	int phy_tx_pow_lev2_len;
	char *phy_tx_pow_lev3;
	int phy_tx_pow_lev3_len;
	char *phy_tx_pow_lev4;
	int phy_tx_pow_lev4_len;
	char *phy_tx_pow_lev5;
	int phy_tx_pow_lev5_len;
	char *phy_tx_pow_lev6;
	int phy_tx_pow_lev6_len;
	char *phy_tx_pow_lev7;
	int phy_tx_pow_lev7_len;
	char *phy_tx_pow_lev8;
	int phy_tx_pow_lev8_len;
	char *cur_tx_pow_lev;
	int cur_tx_pow_lev_len; 

};

static int CheckAndRetrieveNumSuppPowerLevel(xmlDocPtr );
static int CheckAndRetrieveTxPowerLevel1(xmlDocPtr );
static int CheckAndRetrieveTxPowerLevel2(xmlDocPtr );
static int CheckAndRetrieveTxPowerLevel3(xmlDocPtr );
static int CheckAndRetrieveTxPowerLevel4(xmlDocPtr );
static int CheckAndRetrieveTxPowerLevel5(xmlDocPtr );
static int CheckAndRetrieveTxPowerLevel6(xmlDocPtr );
static int CheckAndRetrieveTxPowerLevel7(xmlDocPtr );
static int CheckAndRetrieveTxPowerLevel8(xmlDocPtr );
static int CheckAndRetrieveCurrentTxPowerLevel(xmlDocPtr );
static void lcl_num_supp_pow_levels_xml(xmlDocPtr , xmlNodePtr );
static void lcl_phy_tx_power_level_1_xml(xmlDocPtr , xmlNodePtr );
static void lcl_phy_tx_power_level_2_xml(xmlDocPtr , xmlNodePtr );
static void lcl_phy_tx_power_level_3_xml(xmlDocPtr , xmlNodePtr );
static void lcl_phy_tx_power_level_4_xml(xmlDocPtr , xmlNodePtr );
static void lcl_phy_tx_power_level_5_xml(xmlDocPtr , xmlNodePtr );
static void lcl_phy_tx_power_level_6_xml(xmlDocPtr , xmlNodePtr );
static void lcl_phy_tx_power_level_7_xml(xmlDocPtr , xmlNodePtr );
static void lcl_phy_tx_power_level_8_xml(xmlDocPtr , xmlNodePtr );
static void lcl_curr_tx_power_level_xml(xmlDocPtr cnt_doc, xmlNodePtr cur);

static void GetNumberSupportedPowerLevels(xmlDocPtr, int);
static void GetPowerLevel1(xmlDocPtr, int);
static void GetPowerLevel2(xmlDocPtr, int);
static void GetPowerLevel3(xmlDocPtr, int);
static void GetPowerLevel4(xmlDocPtr, int);
static void GetPowerLevel5(xmlDocPtr, int);
static void GetPowerLevel6(xmlDocPtr, int);
static void GetPowerLevel7(xmlDocPtr, int);
static void GetPowerLevel8(xmlDocPtr, int);
static void GetCurrentTxPowerLevel(xmlDocPtr, int);
#endif  /* __LCL_PHY_TX_POWER_H__*/
