#ifndef __LCL_PRIVACY_H___
#define __LCL_PRIVACY_H___

#include<stdarg.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include "xmlutils.h"
#include "privacy.h"

#define TRUE	1
#define FALSE	2

/* columns present in station config tables */
#define PRIV_PRIVACY_INVOKED            "dot11-privacy-invoked"
#define PRIV_WEP_DEFAULT_KEY_ID         "wep-default-key"
#define PRIV_WEP_KEY_MAPPING_LENGTH     "wep-key-mapping-length"

struct priv_data_info {
	char *priv_invoked;
	int priv_invoked_len;
	char *wep_default_key_id;
	int wep_default_key_id_len;
	char *wep_key_map_length;
	int wep_key_map_length_len;
};

static int CheckAndRetrievePrivInvoked(xmlDocPtr);
static int CheckAndRetrieveWEPDefaultKeyID(xmlDocPtr);
static int CheckAndRetrieveWEPKeyMapLength(xmlDocPtr);

static void lcl_priv_invoked_xml(xmlDocPtr, xmlNodePtr);
static void lcl_wep_default_key_id_xml(xmlDocPtr, xmlNodePtr);
static void lcl_auth_wep_key_map_length_xml(xmlDocPtr, xmlNodePtr);

static void GetPrivacyInvoked(xmlDocPtr, int);
static void GetWEPDefaultKeyID(xmlDocPtr, int);
static void GetWEPKeyMappingLength(xmlDocPtr, int);
static void GetExcludeUnEncrypt(int);
static void GetWEPICVErrorCount(int);
static void GetWEPExcludedCount(int);
#endif  /* __LCL_PRIVACY_H__*/
