#ifndef __STATION_CONFIG_H___
#define __STATION_CONFIG_H___


typedef struct StaConf_info_s{
	int if_index;		/* Interface index */
	char station_id[6];	/* MacAddress */
	int station_id_len;
	int med_occu_limit;	/* Integer ranges from 0 to 1000 */
	int cf_pollable;	/* Integer values either TRUE or FALSE */
	int cfp_period;		/* Integer ranges from 0 to 255 */
	int cfp_max_duration;	/* Integer ranges from 0 to 65535 */
	int auth_rsp_tout;	/* Integer ranges from 0 to 4294967295 */ 
	int priv_opt_impl;	/* Integer value TRUE or FALSE */
	int pow_mgmt_mode;	/* Values such as Active(1) or PowerSave(2) */
	char des_ssid[32];	/* String data type */
	int des_ssid_len;
	int des_bss;		/* Values such as Infrastructure(1), Independent(2) or Any(3) */
	char oper_rate[126];	/* String data type */ 
	int oper_rate_len;
	int beacon_period;	/* Integer ranges from 1 to 65535 */
	int dtim_period;	/* Integer ranges from 1 to 255 */
	int ass_res_to;		/* Integer ranges from 0 to 4294967295 */
	int disass_res;		/* Integer ranges from 0 to 65535 */
	char disass_sta[6];	/* MacAddress */
	int disass_sta_len;
	int deauth_res;		/* Integer ranges from 0 to 65535 */
	char deauth_sta[6];	/* MacAddress */
	int deauth_sta_len;
	int authfail_status;	/* Integer ranges from 0 to 65535 */
	char authfail_sta[6];	/* MacAddress */
	int authfail_sta_len;
	int multi_domain_impl;	/* Integer value TRUE or FALSE */
	int multi_domain_ena;	/* Integer value TRUE or FALSE */
	char country[3];	/* String data type */
}StaConf_info;

int GetStationConfigEntries(void);
int GetStationConfigTableData(void);
int GetStationConfigTableIndexCount(void);
void GetStationConfigEntryByIndex(int index, StaConf_info *entry);
int SetDesiredSSID(StaConf_info *info, char *val, int len);
int SetStationId(StaConf_info *info, char *val, int len);
int SetAuthenticationResponseTimeout(StaConf_info *info, int *val, int len);
int SetAuthenticationResponseTimeout(StaConf_info *info, int *val, int len);
int SetDtimPeriod(StaConf_info *info, int *val, int len);
int SetBeaconPeriod(StaConf_info *info, int *val, int len);
#endif  /* __STATION_CONFIG_H___*/
