<?xml version="1.0"?>
<I802config>
  <system>
    <model>CONFIG_OAP_MODEL</model>
    <encrypted-password>2yn.4fvaTgedM</encrypted-password>
    <country>us</country>
  </system>

  <configuration>
    <version>1.02</version>
  </configuration>

  <host>
    <id>CONFIG_OAP_SYSNAME_DEFAULT</id>
    <static-domain>example.com</static-domain>
    <dns-via-dhcp>up</dns-via-dhcp>
  </host>

  <config/>

  <interface name="lo">
    <description>Loopback</description>
    <type>loopback</type>
    <status>up</status>
    <static-ip>127.0.0.1</static-ip>
  </interface>

#ifdef CONFIG_OAP_PRODUCT_SMB
  <!-- There are two possible configurations for the Ethernet interfaces
       of the Self-Managed AP:
       1. eth0 is Internal, eth1 is Guest, vlans are not in use.
       2. eth0 vlanX is Internal, eth0 vlanY is Guest, eth1 is not in use. 
       The default is 1. -->
#endif

#ifdef CONFIG_OAP_WAN_INTERFACE
  <interface name="eth0">
    <description>Ethernet - WAN</description>
    <type>ethernet</type>
    <status>up</status>
    <static-ip></static-ip>
    <nat>on</nat>
  </interface>
#elif defined CONFIG_OAP_GUEST
  <interface name="eth0">
    <description>Ethernet - Internal</description>
    <type>ethernet</type>
    <status>up</status>
    <static-ip></static-ip>
  </interface>
#else
  <interface name="eth0">
    <description>Ethernet - Internal</description>
    <type>ethernet</type>
    <status>up</status>
    <static-ip></static-ip>
  </interface>
#endif

#ifdef CONFIG_OAP_WAN_INTERFACE
  <interface name="eth1">
    <description>Ethernet - LAN</description>
    <type>ethernet</type>
    <status>up</status>
    <static-ip>0.0.0.0</static-ip>
  </interface>
#elif defined CONFIG_OAP_GUEST
  <interface name="eth1">
    <description>Ethernet - Guest</description>
    <type>ethernet</type>
#ifdef CONFIG_OAP_DEMO_GUEST_BSSID
    <status>down</status>
#else
#ifdef CONFIG_OAP_GUEST_DEFAULT_ENABLED
    <status>up</status>
#else
    <status>down</status>
#endif /* CONFIG_OAP_GUEST_DEFAULT_ENABLED */
#endif /* CONFIG_OAP_DEMO_GUEST_BSSID */
    <static-ip>0.0.0.0</static-ip>
  </interface>
#endif /* CONFIG_OAP_WAN_INTERFACE */

  <!-- Bridges - Must come before seviceSet interfaces. -->

  <interface name="br0">
    <description>Bridge - Internal</description>
    <type>bridge</type>
    <status>up</status>
#ifdef CONFIG_OAP_STATIC_DEFAULTS
    <static-ip>CONFIG_OAP_STATIC_DEFAULT_IP</static-ip>
    <static-mask>CONFIG_OAP_STATIC_DEFAULT_MASK</static-mask>
#endif
#ifdef CONFIG_OAP_BRIDGE_STP
    <stp>off</stp>
    <hello>2.0</hello>
    <fd>15.0</fd>
    <priority>32768</priority>
#endif
#if defined(CONFIG_OAP_STATION_ISOLATION) && defined(CONFIG_OAP_RADIOS_2)
    <port-isolation>off</port-isolation>
#endif
  </interface>

#ifdef CONFIG_OAP_GUEST
  <interface name="brguest">
    <description>Bridge - Guest</description>
    <type>bridge</type>
#ifdef CONFIG_OAP_GUEST_DEFAULT_ENABLED
    <status>up</status>
#else
    <status>down</status>
#endif
#ifdef CONFIG_OAP_BRIDGE_STP
    <stp>off</stp>
    <hello>2.0</hello>
    <fd>15.0</fd>
    <priority>32768</priority>
#endif
#if defined(CONFIG_OAP_STATION_ISOLATION) && defined(CONFIG_OAP_RADIOS_2)
    <port-isolation>off</port-isolation>
#endif
  </interface>
#endif

#ifdef CONFIG_OAP_VIRTUAL_WIRELESS_NETWORKS
  <interface name="brvwn1">
    <description>Bridge - Virtual Wireless Network 1</description>
    <type>bridge</type>
    <status>down</status>
  </interface>

  <bridge-port name="brvwn1">
    <interface>wlan0vwn1</interface>
  </bridge-port>
#ifdef CONFIG_OAP_RADIOS_2
  <bridge-port name="brvwn1">
    <interface>wlan1vwn1</interface>
  </bridge-port>
#endif /* CONFIG_OAP_RADIOS_2 */

  <interface name="brvwn2">
    <description>Bridge - Virtual Wireless Network 2</description>
    <type>bridge</type>
    <status>down</status>
  </interface>

  <bridge-port name="brvwn2">
    <interface>wlan0vwn2</interface>
  </bridge-port>
#ifdef CONFIG_OAP_RADIOS_2
  <bridge-port name="brvwn2">
    <interface>wlan1vwn2</interface>
  </bridge-port>
#endif /* CONFIG_OAP_RADIOS_2 */
#endif /* CONFIG_OAP_VIRTUAL_WIRELESS_NETWORKS */

#ifdef CONFIG_OAP_ORCHESTRATOR
  <ip-route>
    <gateway>192.168.1.254</gateway>
    <destination>0.0.0.0</destination>
    <mask>0.0.0.0</mask>
  </ip-route>
#endif

  <dot11>
    <status>up</status>
    <debug>0</debug>
    <dot11d>up</dot11d>
  </dot11>

  <radio name="wlan0">
#ifdef CONFIG_OAP_RADIOS_2
#ifdef CONFIG_OAP_RADIO_1_MODE_A
    <description>Radio 1 - IEEE 802.11a</description>
#else /* CONFIG_OAP_RADIO_1_MODE_A */
    <description>Radio 1 - IEEE 802.11g</description>
#endif /* CONFIG_OAP_RADIO_1_MODE_A */
#else /* CONFIG_OAP_RADIOS_2 */
    <description>IEEE 802.11</description>
#endif /* CONFIG_OAP_RADIOS_2 */
    <status>up</status>
#ifdef CONFIG_OAP_GUEST
#ifdef CONFIG_OAP_VIRTUAL_WIRELESS_NETWORKS
    <max-bss>4</max-bss>
#else
    <max-bss>2</max-bss>
#endif
#else /* CONFIG_OAP_GUEST */
#ifdef CONFIG_OAP_VIRTUAL_WIRELESS_NETWORKS
    <max-bss>3</max-bss>
#else
    <max-bss>1</max-bss>
#endif
#endif /* CONFIG_OAP_GUEST */
#ifdef CONFIG_OAP_RADIO_1_AUTO_CHANNEL
    <channel-policy>best</channel-policy>
#else
    <channel-policy>static</channel-policy>
#endif
#ifdef CONFIG_OAP_RADIO_1_MODE_DEFAULT_A
    <static-channel>52</static-channel>
    <mode>a</mode>
#elif defined CONFIG_OAP_RADIO_1_MODE_DEFAULT_G
    <static-channel>6</static-channel>
    <mode>g</mode>
#endif
    <tx-power>100</tx-power>
    <tx-rx-status>up</tx-rx-status>
    <beacon-interval>100</beacon-interval>
    <fragmentation-threshold>2346</fragmentation-threshold>
    <rts-threshold>2347</rts-threshold>
#ifdef CONFIG_OAP_LOAD_BALANCING
    <load-balance-disassociation-utilization>0</load-balance-disassociation-utilization>
    <load-balance-disassociation-stations>0</load-balance-disassociation-stations>
    <load-balance-no-association-utilization>0</load-balance-no-association-utilization>
#endif
#ifdef CONFIG_OAP_AP_DETECTION
    <ap-detection>on</ap-detection>
#endif
#ifdef CONFIG_OAP_QOS
    <wme>on</wme>
#ifdef CONFIG_OAP_QOS_WME_WIFI_NOACK_TEST
    <wme_wifi_noack_test>off</wme_wifi_noack_test>
#endif
#endif /* CONFIG_OAP_QOS */
#ifdef CONFIG_OAP_STATION_ISOLATION
    <station-isolation>off</station-isolation>
#endif
#ifdef CONFIG_OAP_RADIO_SUPER_AG
    <super-ag>no</super-ag>
#endif
  </radio>

#ifdef CONFIG_OAP_GUEST
  <bss name="wlan0bssInternal">
#else
  <bss name="wlan0bss">
#endif
#ifdef CONFIG_OAP_GUEST
#ifdef CONFIG_OAP_RADIOS_2
    <description>Internal - Radio 1</description>
#else
    <description>Internal</description>
#endif
#else
#ifdef CONFIG_OAP_RADIOS_2
    <description>Radio 1</description>
#else
    <description>Basic Service Set</description>
#endif
#endif
    <status>up</status>
    <radio>wlan0</radio>
    <beacon-interface>wlan0</beacon-interface>
    <ignore-broadcast-ssid>off</ignore-broadcast-ssid>
    <mac-acl-mode>deny-list</mac-acl-mode>
    <mac-acl-name>default</mac-acl-name>
#ifdef CONFIG_OAP_ORCHESTRATOR
    <radius-ip>127.0.0.1</radius-ip>
    <radius-key>secret</radius-key>
#endif
    <radius-accounting>off</radius-accounting>
    <dtim-period>2</dtim-period>
    <max-stations>2007</max-stations>
    <open-system-authentication>on</open-system-authentication>
    <shared-key-authentication>off</shared-key-authentication>
    <wpa-cipher-tkip>on</wpa-cipher-tkip>
    <wpa-cipher-ccmp>off</wpa-cipher-ccmp>
    <wpa-allow-non-wpa-stations>off</wpa-allow-non-wpa-stations>
#ifdef CONFIG_OAP_WPA2
    <wpa-allowed>on</wpa-allowed>
    <wpa2-allowed>on</wpa2-allowed>
    <rsn-preauthentication>off</rsn-preauthentication>
#endif
  </bss>

  <interface name="wlan0">
#ifdef CONFIG_OAP_GUEST
#ifdef CONFIG_OAP_RADIOS_2
    <description>Wireless - Internal - Radio 1</description>
#else
    <description>Wireless - Internal</description>
#endif
#else
#ifdef CONFIG_OAP_RADIOS_2
    <description>Wireless - Radio 1</description>
#else
    <description>Wireless</description>
#endif
#endif
    <type>service-set</type>
    <status>up</status>
    <static-ip>0.0.0.0</static-ip>
#ifdef CONFIG_OAP_GUEST
    <bss>wlan0bssInternal</bss>
#else
    <bss>wlan0bss</bss>
#endif
    <ssid>CONFIG_OAP_RADIO_1_SSID_DEFAULT</ssid>
    <security>plain-text</security>
    <wep-default-key>1</wep-default-key>
    <wep-key-length>104</wep-key-length>
    <wep-key-ascii>no</wep-key-ascii>
  </interface>

#ifdef CONFIG_OAP_GUEST
  <bss name="wlan0bssGuest">
#ifdef CONFIG_OAP_RADIOS_2
    <description>Guest - Radio 1</description>
#else
    <description>Guest</description>
#endif
#ifdef CONFIG_OAP_GUEST_DEFAULT_ENABLED
    <status>up</status>
#else
    <status>down</status>
#endif
    <radio>wlan0</radio>
    <beacon-interface>wlan0guest</beacon-interface>
    <ignore-broadcast-ssid>off</ignore-broadcast-ssid>
    <mac-acl-mode>deny-list</mac-acl-mode>
    <mac-acl-name>default</mac-acl-name>
    <radius-accounting>off</radius-accounting>
    <dtim-period>2</dtim-period>
    <max-stations>2007</max-stations>
    <open-system-authentication>on</open-system-authentication>
    <shared-key-authentication>off</shared-key-authentication>
    <wpa-cipher-tkip>on</wpa-cipher-tkip>
    <wpa-cipher-ccmp>off</wpa-cipher-ccmp>
    <wpa-allow-non-wpa-stations>off</wpa-allow-non-wpa-stations>
#ifdef CONFIG_OAP_WPA2
    <wpa-allowed>on</wpa-allowed>
    <wpa2-allowed>on</wpa2-allowed>
    <rsn-preauthentication>off</rsn-preauthentication>
#endif
  </bss>

  <interface name="wlan0guest">
#ifdef CONFIG_OAP_RADIOS_2
    <description>Wireless - Guest - Radio 1</description>
#else
    <description>Wireless - Guest</description>
#endif
    <type>service-set</type>
    <status>up</status>
    <static-ip>0.0.0.0</static-ip>
    <bss>wlan0bssGuest</bss>
    <ssid>CONFIG_OAP_RADIO_1_SSID_GUEST_DEFAULT</ssid>
  </interface>
#endif

#ifdef CONFIG_OAP_VIRTUAL_WIRELESS_NETWORKS

  <bss name="wlan0bssvwn1">
#ifdef CONFIG_OAP_RADIOS_2
    <description>Virtual Wireless Network 1 - Radio 1</description>
#else
    <description>Virtual Wireless Network 1</description>
#endif
    <status>down</status>
    <radio>wlan0</radio>
    <beacon-interface>wlan0vwn1</beacon-interface>
    <ignore-broadcast-ssid>off</ignore-broadcast-ssid>
    <mac-acl-mode>deny-list</mac-acl-mode>
    <mac-acl-name>default</mac-acl-name>
#ifdef CONFIG_OAP_ORCHESTRATOR
    <radius-ip>127.0.0.1</radius-ip>
    <radius-key>secret</radius-key>
#endif
    <radius-accounting>off</radius-accounting>
    <dtim-period>2</dtim-period>
    <max-stations>2007</max-stations>
    <open-system-authentication>on</open-system-authentication>
    <shared-key-authentication>off</shared-key-authentication>
    <wpa-cipher-tkip>on</wpa-cipher-tkip>
    <wpa-cipher-ccmp>off</wpa-cipher-ccmp>
    <wpa-allow-non-wpa-stations>off</wpa-allow-non-wpa-stations>
#ifdef CONFIG_OAP_WPA2
    <wpa-allowed>on</wpa-allowed>
    <wpa2-allowed>on</wpa2-allowed>
    <rsn-preauthentication>off</rsn-preauthentication>
#endif
  </bss>

  <interface name="wlan0vwn1">
#ifdef CONFIG_OAP_RADIOS_2
    <description>Wireless - Virtual Wireless Network 1 - Radio 1</description>
#else
    <description>Wireless - Virtual Wireless Network 1</description>
#endif
    <type>service-set</type>
    <status>up</status>
    <bss>wlan0bssvwn1</bss>
    <ssid>Virtual Wireless Network 1</ssid>
    <security>plain-text</security>
    <wep-default-key>1</wep-default-key>
    <wep-key-length>104</wep-key-length>
    <wep-key-ascii>no</wep-key-ascii>
  </interface>


  <bss name="wlan0bssvwn2">
#ifdef CONFIG_OAP_RADIOS_2
    <description>Virtual Wireless Network 2 - Radio 1</description>
#else
    <description>Virtual Wireless Network 2</description>
#endif
    <status>down</status>
    <radio>wlan0</radio>
    <beacon-interface>wlan0vwn2</beacon-interface>
    <ignore-broadcast-ssid>off</ignore-broadcast-ssid>
    <mac-acl-mode>deny-list</mac-acl-mode>
    <mac-acl-name>default</mac-acl-name>
#ifdef CONFIG_OAP_ORCHESTRATOR
    <radius-ip>127.0.0.1</radius-ip>
    <radius-key>secret</radius-key>
#endif
    <radius-accounting>off</radius-accounting>
    <dtim-period>2</dtim-period>
    <max-stations>2007</max-stations>
    <open-system-authentication>on</open-system-authentication>
    <shared-key-authentication>off</shared-key-authentication>
    <wpa-cipher-tkip>on</wpa-cipher-tkip>
    <wpa-cipher-ccmp>off</wpa-cipher-ccmp>
    <wpa-allow-non-wpa-stations>off</wpa-allow-non-wpa-stations>
#ifdef CONFIG_OAP_WPA2
    <wpa-allowed>on</wpa-allowed>
    <wpa2-allowed>on</wpa2-allowed>
    <rsn-preauthentication>off</rsn-preauthentication>
#endif
  </bss>

  <interface name="wlan0vwn2">
#ifdef CONFIG_OAP_RADIOS_2
    <description>Wireless - Virtual Wireless Network 2 - Radio 1</description>
#else
    <description>Wireless - Virtual Wireless Network 2</description>
#endif
    <type>service-set</type>
    <status>up</status>
    <bss>wlan0bssvwn2</bss>
    <ssid>Virtual Wireless Network 2</ssid>
    <security>plain-text</security>
    <wep-default-key>1</wep-default-key>
    <wep-key-length>104</wep-key-length>
    <wep-key-ascii>no</wep-key-ascii>
  </interface>

#endif /* CONFIG_OAP_VIRTUAL_WIRELESS_NETWORKS */

#ifdef CONFIG_OAP_RADIOS_2
  <radio name="wlan1">
#ifdef CONFIG_OAP_RADIO_2_MODE_A
    <description>Radio 2 - IEEE 802.11a</description>
#else /* CONFIG_OAP_RADIO_2_MODE_A */
    <description>Radio 2 - IEEE 802.11g</description>
#endif /* CONFIG_OAP_RADIO_2_MODE_A */
    <status>up</status>
#ifdef CONFIG_OAP_GUEST
#ifdef CONFIG_OAP_VIRTUAL_WIRELESS_NETWORKS
    <max-bss>4</max-bss>
#else
    <max-bss>2</max-bss>
#endif
#else /* CONFIG_OAP_GUEST */
#ifdef CONFIG_OAP_VIRTUAL_WIRELESS_NETWORKS
    <max-bss>3</max-bss>
#else
    <max-bss>1</max-bss>
#endif
#endif /* CONFIG_OAP_GUEST */
#ifdef CONFIG_OAP_RADIO_2_AUTO_CHANNEL
    <channel-policy>best</channel-policy>
#else
    <channel-policy>static</channel-policy>
#endif
#ifdef CONFIG_OAP_RADIO_2_MODE_DEFAULT_A
    <static-channel>52</static-channel>
    <mode>a</mode>
#elif defined CONFIG_OAP_RADIO_2_MODE_DEFAULT_G
    <static-channel>6</static-channel>
    <mode>g</mode>
#endif
    <tx-power>100</tx-power>
    <tx-rx-status>up</tx-rx-status>
    <beacon-interval>100</beacon-interval>
    <fragmentation-threshold>2346</fragmentation-threshold>
    <rts-threshold>2347</rts-threshold>
#ifdef CONFIG_OAP_LOAD_BALANCING
    <load-balance-disassociation-utilization>0</load-balance-disassociation-utilization>
    <load-balance-disassociation-stations>0</load-balance-disassociation-stations>
    <load-balance-no-association-utilization>0</load-balance-no-association-utilization>
#endif
#ifdef CONFIG_OAP_AP_DETECTION
    <ap-detection>on</ap-detection>
#endif
#ifdef CONFIG_OAP_QOS
    <wme>on</wme>
#ifdef CONFIG_OAP_QOS_WME_WIFI_NOACK_TEST
    <wme_wifi_noack_test>off</wme_wifi_noack_test>
#endif
#endif /* CONFIG_OAP_QOS */
#ifdef CONFIG_OAP_STATION_ISOLATION
    <station-isolation>off</station-isolation>
#endif
#ifdef CONFIG_OAP_RADIO_SUPER_AG
    <super-ag>no</super-ag>
#endif
  </radio>

#ifdef CONFIG_OAP_GUEST
  <bss name="wlan1bssInternal">
#else
  <bss name="wlan1bss">
#endif
#ifdef CONFIG_OAP_GUEST
    <description>Internal - Radio 2</description>
#else
    <description>Radio 2</description>
#endif
    <status>up</status>
    <radio>wlan1</radio>
    <beacon-interface>wlan1</beacon-interface>
    <ignore-broadcast-ssid>off</ignore-broadcast-ssid>
    <mac-acl-mode>deny-list</mac-acl-mode>
    <mac-acl-name>default</mac-acl-name>
#ifdef CONFIG_OAP_ORCHESTRATOR
    <radius-ip>127.0.0.1</radius-ip>
    <radius-key>secret</radius-key>
#endif
    <radius-accounting>off</radius-accounting>
    <dtim-period>2</dtim-period>
    <max-stations>2007</max-stations>
    <open-system-authentication>on</open-system-authentication>
    <shared-key-authentication>off</shared-key-authentication>
    <wpa-cipher-tkip>on</wpa-cipher-tkip>
    <wpa-cipher-ccmp>off</wpa-cipher-ccmp>
    <wpa-allow-non-wpa-stations>off</wpa-allow-non-wpa-stations>
#ifdef CONFIG_OAP_WPA2
    <wpa-allowed>on</wpa-allowed>
    <wpa2-allowed>on</wpa2-allowed>
    <rsn-preauthentication>off</rsn-preauthentication>
#endif
  </bss>

  <interface name="wlan1">
#ifdef CONFIG_OAP_GUEST
    <description>Wireless - Internal - Radio 2</description>
#else
    <description>Wireless - Radio 2</description>
#endif
    <type>service-set</type>
    <status>up</status>
    <static-ip>0.0.0.0</static-ip>
#ifdef CONFIG_OAP_GUEST
    <bss>wlan1bssInternal</bss>
#else
    <bss>wlan1bss</bss>
#endif
    <ssid>CONFIG_OAP_RADIO_2_SSID_DEFAULT</ssid>
    <security>plain-text</security>
    <wep-default-key>1</wep-default-key>
    <wep-key-length>104</wep-key-length>
    <wep-key-ascii>no</wep-key-ascii>
  </interface>

#ifdef CONFIG_OAP_GUEST
  <bss name="wlan1bssGuest">
    <description>Guest - Radio 2</description>
#ifdef CONFIG_OAP_GUEST_DEFAULT_ENABLED
    <status>up</status>
#else
    <status>down</status>
#endif
    <radio>wlan1</radio>
    <beacon-interface>wlan1guest</beacon-interface>
    <ignore-broadcast-ssid>off</ignore-broadcast-ssid>
    <mac-acl-mode>deny-list</mac-acl-mode>
    <mac-acl-name>default</mac-acl-name>
    <radius-accounting>off</radius-accounting>
    <dtim-period>2</dtim-period>
    <max-stations>2007</max-stations>
    <open-system-authentication>on</open-system-authentication>
    <shared-key-authentication>off</shared-key-authentication>
    <wpa-cipher-tkip>on</wpa-cipher-tkip>
    <wpa-cipher-ccmp>off</wpa-cipher-ccmp>
    <wpa-allow-non-wpa-stations>off</wpa-allow-non-wpa-stations>
#ifdef CONFIG_OAP_WPA2
    <wpa-allowed>on</wpa-allowed>
    <wpa2-allowed>on</wpa2-allowed>
    <rsn-preauthentication>off</rsn-preauthentication>
#endif
  </bss>

  <interface name="wlan1guest">
    <description>Wireless - Guest - Radio 2</description>
    <type>service-set</type>
    <status>up</status>
    <static-ip>0.0.0.0</static-ip>
    <bss>wlan1bssGuest</bss>
    <ssid>CONFIG_OAP_RADIO_2_SSID_GUEST_DEFAULT</ssid>
  </interface>
#endif

#ifdef CONFIG_OAP_VIRTUAL_WIRELESS_NETWORKS

  <bss name="wlan1bssvwn1">
    <description>Virtual Wireless Network 1 - Radio 2</description>
    <status>down</status>
    <radio>wlan1</radio>
    <beacon-interface>wlan1vwn1</beacon-interface>
    <ignore-broadcast-ssid>off</ignore-broadcast-ssid>
    <mac-acl-mode>deny-list</mac-acl-mode>
    <mac-acl-name>default</mac-acl-name>
#ifdef CONFIG_OAP_ORCHESTRATOR
    <radius-ip>127.0.0.1</radius-ip>
    <radius-key>secret</radius-key>
#endif
    <radius-accounting>off</radius-accounting>
    <dtim-period>2</dtim-period>
    <max-stations>2007</max-stations>
    <open-system-authentication>on</open-system-authentication>
    <shared-key-authentication>off</shared-key-authentication>
    <wpa-cipher-tkip>on</wpa-cipher-tkip>
    <wpa-cipher-ccmp>off</wpa-cipher-ccmp>
    <wpa-allow-non-wpa-stations>off</wpa-allow-non-wpa-stations>
#ifdef CONFIG_OAP_WPA2
    <wpa-allowed>on</wpa-allowed>
    <wpa2-allowed>on</wpa2-allowed>
    <rsn-preauthentication>off</rsn-preauthentication>
#endif
  </bss>

  <interface name="wlan1vwn1">
    <description>Wireless - Virtual Wireless Network 1 - Radio 2</description>
    <type>service-set</type>
    <status>up</status>
    <bss>wlan1bssvwn1</bss>
    <ssid>Virtual Wireless Network 1</ssid>
    <security>plain-text</security>
    <wep-default-key>1</wep-default-key>
    <wep-key-length>104</wep-key-length>
    <wep-key-ascii>no</wep-key-ascii>
  </interface>


  <bss name="wlan1bssvwn2">
    <description>Virtual Wireless Network 2 - Radio 2</description>
    <status>down</status>
    <radio>wlan1</radio>
    <beacon-interface>wlan1vwn2</beacon-interface>
    <ignore-broadcast-ssid>off</ignore-broadcast-ssid>
    <mac-acl-mode>deny-list</mac-acl-mode>
    <mac-acl-name>default</mac-acl-name>
#ifdef CONFIG_OAP_ORCHESTRATOR
    <radius-ip>127.0.0.1</radius-ip>
    <radius-key>secret</radius-key>
#endif
    <radius-accounting>off</radius-accounting>
    <dtim-period>2</dtim-period>
    <max-stations>2007</max-stations>
    <open-system-authentication>on</open-system-authentication>
    <shared-key-authentication>off</shared-key-authentication>
    <wpa-cipher-tkip>on</wpa-cipher-tkip>
    <wpa-cipher-ccmp>off</wpa-cipher-ccmp>
    <wpa-allow-non-wpa-stations>off</wpa-allow-non-wpa-stations>
#ifdef CONFIG_OAP_WPA2
    <wpa-allowed>on</wpa-allowed>
    <wpa2-allowed>on</wpa2-allowed>
    <rsn-preauthentication>off</rsn-preauthentication>
#endif
  </bss>

  <interface name="wlan1vwn2">
    <description>Wireless - Virtual Wireless Network 2 - Radio 2</description>
    <type>service-set</type>
    <status>up</status>
    <bss>wlan1bssvwn2</bss>
    <ssid>Virtual Wireless Network 2</ssid>
    <security>plain-text</security>
    <wep-default-key>1</wep-default-key>
    <wep-key-length>104</wep-key-length>
    <wep-key-ascii>no</wep-key-ascii>
  </interface>

#endif /* CONFIG_OAP_VIRTUAL_WIRELESS_NETWORKS */

#endif /* CONFIG_OAP_RADIOS_2 */

#ifdef CONFIG_OAP_WAN_INTERFACE
  <bridge-port name="br0">
    <interface>eth1</interface>
  </bridge-port>
  <bridge-port name="br0">
    <interface>wlan0</interface>
  </bridge-port>
#ifdef CONFIG_OAP_RADIOS_2
  <bridge-port name="br0">
    <interface>wlan1</interface>
  </bridge-port>
#endif /* CONFIG_OAP_RADIOS_2 */

#ifdef CONFIG_OAP_DHCP_CLIENT
  <dhcp-client>
#ifdef CONFIG_OAP_DHCP_CLIENT_DEFAULT_ON
    <status>up</status>
#else
    <status>down</status>
#endif
    <interface>eth0</interface>
  </dhcp-client>
#endif
#elif defined CONFIG_OAP_GUEST
  <bridge-port name="br0">
    <interface>eth0</interface>
  </bridge-port>
  <bridge-port name="br0">
    <interface>wlan0</interface>
  </bridge-port>
#ifdef CONFIG_OAP_RADIOS_2
  <bridge-port name="br0">
    <interface>wlan1</interface>
  </bridge-port>
#endif /* CONFIG_OAP_RADIOS_2 */

#ifdef CONFIG_OAP_DHCP_CLIENT
  <dhcp-client>
#ifdef CONFIG_OAP_DHCP_CLIENT_DEFAULT_ON
    <status>up</status>
#else
    <status>down</status>
#endif
    <interface>br0</interface>
  </dhcp-client>
#endif

#if defined(CONFIG_OAP_GUEST_DEFAULT_ENABLED) && \
    !defined(CONFIG_OAP_DEMO_GUEST_BSSID)
  <bridge-port name="brguest">
    <interface>eth1</interface>
  </bridge-port>
#endif
  <bridge-port name="brguest">
    <interface>wlan0guest</interface>
  </bridge-port>
#ifdef CONFIG_OAP_RADIOS_2
  <bridge-port name="brguest">
    <interface>wlan1guest</interface>
  </bridge-port>
#endif /* CONFIG_OAP_RADIOS_2 */
#endif /* CONFIG_OAP_GUEST */

#ifdef CONFIG_OAP_PORTAL
  <portal>
#ifdef CONFIG_OAP_GUEST_DEFAULT_ENABLED
    <status>up</status>
#else
    <status>down</status>
#endif
#ifdef CONFIG_OAP_PORTAL_DEFAULT_WELCOME_ENABLED
    <welcome-screen>on</welcome-screen>
#else
    <welcome-screen>off</welcome-screen>
#endif
    <welcome-screen-text>CONFIG_OAP_PORTAL_DEFAULT_WELCOME_TEXT</welcome-screen-text>
  </portal> 
#endif

#ifdef CONFIG_OAP_WDS
  <!--UI needs these to be here by default,
       since it just sets the status up and down. -->
  <interface name="wlan0wds0">
    <description>Wireless Distribution System - Link 1</description>
    <type>wds</type>
    <status>down</status>
    <radio>wlan0</radio>
    <wep-key-length>104</wep-key-length>
    <wep-key-ascii>no</wep-key-ascii>
  </interface>
  <interface name="wlan0wds1">
    <description>Wireless Distribution System - Link 2</description>
    <type>wds</type>
    <status>down</status>
    <radio>wlan0</radio>
    <wep-key-length>104</wep-key-length>
    <wep-key-ascii>no</wep-key-ascii>
  </interface>
  <interface name="wlan0wds2">
    <description>Wireless Distribution System - Link 3</description>
    <type>wds</type>
    <status>down</status>
    <radio>wlan0</radio>
    <wep-key-length>104</wep-key-length>
    <wep-key-ascii>no</wep-key-ascii>
  </interface>
  <interface name="wlan0wds3">
    <description>Wireless Distribution System - Link 4</description>
    <type>wds</type>
    <status>down</status>
    <radio>wlan0</radio>
    <wep-key-length>104</wep-key-length>
    <wep-key-ascii>no</wep-key-ascii>
  </interface>
#endif

#ifdef CONFIG_OAP_DNSMASQ
  <dnsmasq>
    <status>up</status>
    <interface>br0</interface>
  </dnsmasq>
#endif

#ifdef CONFIG_OAP_TINYPROXY
  <tinyproxy>
    <status>up</status>
  </tinyproxy>
#endif

#ifdef CONFIG_OAP_FIREWALL  
  <firewall>
    <status>up</status>
    <ids-status>down</ids-status>
    <vpn-pass-through-status>down</vpn-pass-through-status>
    <ipsec-pass-through-status>down</ipsec-pass-through-status>
    <web-port-forward-status>down</web-port-forward-status>
    <ssh-port-forward-status>down</ssh-port-forward-status>
    <ftp-port-forward-status>down</ftp-port-forward-status>
    <other-port-forward-status>down</other-port-forward-status>
    <vpn-pass-through-destination/>
    <ipsec-pass-through-destination/>
    <web-port-forward-destination/>
    <ssh-port-forward-destination/>
    <ftp-port-forward-destination/>
    <other-port-forward-destination/>
    <other-port-forward-port/>
  </firewall>
#endif

#ifdef CONFIG_OAP_PPP
  <interface name="ppp0">
    <type>pppoe</type>
    <status>down</status>
    <username>username</username>
    <pass>pass</pass>
    <interface>eth0</interface>
    <server>10.10.50.2</server>
    <nat>on</nat>
  </interface>
#endif

#ifdef CONFIG_OAP_DHCP_SERVER
  <dhcp-server>
    <status>up</status>
    <dhcpd_detect>on</dhcpd_detect>
    <interface>br0</interface>
    <subnet>255.255.255.0</subnet>
    <startIp>192.168.2.10</startIp>
    <endIp>192.168.2.60</endIp>
    <leaseTime>43200</leaseTime>
    <dns>192.168.2.254</dns>
    <wins/>
  </dhcp-server>
#endif

#ifdef CONFIG_OAP_ECHOD
  <echod>
    <status>down</status>
    <port>2555</port>
  </echod>
#endif

  <log/>

#ifdef CONFIG_OAP_FIREWALL
  <ids-entry/>
#endif

#ifdef CONFIG_OAP_NTPCLIENT
  <ntp>
#ifdef CONFIG_OAP_NTPCLIENT_ENABLED
    <status>up</status>
#else
    <status>down</status>
#endif
#ifdef CONFIG_OAP_NTPCLIENT_USE_SERVER
    <server>CONFIG_OAP_NTPCLIENT_SERVER</server>
#else
    <server></server>
#endif
  </ntp>
#endif

#ifdef CONFIG_OAP_EVAL_MODE
  <eval/>
#endif

#ifdef CONFIG_OAP_RADIO_1_MODE_DEFAULT_A
    <basic-rate name="wlan0">
      <rate>24</rate>
    </basic-rate>
    <basic-rate name="wlan0">
      <rate>12</rate>
    </basic-rate>
    <basic-rate name="wlan0">
      <rate>6</rate>
    </basic-rate>
#elif defined CONFIG_OAP_RADIO_1_MODE_DEFAULT_G
    <basic-rate name="wlan0">
      <rate>11</rate>
    </basic-rate>
    <basic-rate name="wlan0">
      <rate>5.5</rate>
    </basic-rate>
    <basic-rate name="wlan0">
      <rate>2</rate>
    </basic-rate>
    <basic-rate name="wlan0">
      <rate>1</rate>
    </basic-rate>
#endif /* CONFIG_OAP_RADIO_1_MODE_DEFAULT_G */

    <supported-rate name="wlan0">
      <rate>54</rate>
    </supported-rate>
    <supported-rate name="wlan0">
      <rate>48</rate>
    </supported-rate>
    <supported-rate name="wlan0">
      <rate>36</rate>
    </supported-rate>
    <supported-rate name="wlan0">
      <rate>24</rate>
    </supported-rate>
    <supported-rate name="wlan0">
      <rate>18</rate>
    </supported-rate>
    <supported-rate name="wlan0">
      <rate>12</rate>
    </supported-rate>
#ifdef CONFIG_OAP_RADIO_1_MODE_DEFAULT_G
    <supported-rate name="wlan0">
      <rate>11</rate>
    </supported-rate>
#endif
    <supported-rate name="wlan0">
      <rate>9</rate>
    </supported-rate>
    <supported-rate name="wlan0">
      <rate>6</rate>
    </supported-rate>

#ifdef CONFIG_OAP_RADIO_1_MODE_DEFAULT_G
    <supported-rate name="wlan0">
      <rate>5.5</rate>
    </supported-rate>
    <supported-rate name="wlan0">
      <rate>2</rate>
    </supported-rate>
    <supported-rate name="wlan0">
      <rate>1</rate>
    </supported-rate>
#endif /* CONFIG_OAP_RADIO_1_MODE_DEFAULT_G */

#ifdef CONFIG_OAP_RADIOS_2
#ifdef CONFIG_OAP_RADIO_2_MODE_DEFAULT_A
    <basic-rate name="wlan1">
      <rate>24</rate>
    </basic-rate>
    <basic-rate name="wlan1">
      <rate>12</rate>
    </basic-rate>
    <basic-rate name="wlan1">
      <rate>6</rate>
    </basic-rate>
#elif defined CONFIG_OAP_RADIO_2_MODE_DEFAULT_G
    <basic-rate name="wlan1">
      <rate>11</rate>
    </basic-rate>
    <basic-rate name="wlan1">
      <rate>5.5</rate>
    </basic-rate>
    <basic-rate name="wlan1">
      <rate>2</rate>
    </basic-rate>
    <basic-rate name="wlan1">
      <rate>1</rate>
    </basic-rate>
#endif /* CONFIG_OAP_RADIO_2_MODE_DEFAULT_G */

    <supported-rate name="wlan1">
      <rate>54</rate>
    </supported-rate>
    <supported-rate name="wlan1">
      <rate>48</rate>
    </supported-rate>
    <supported-rate name="wlan1">
      <rate>36</rate>
    </supported-rate>
    <supported-rate name="wlan1">
      <rate>24</rate>
    </supported-rate>
    <supported-rate name="wlan1">
      <rate>18</rate>
    </supported-rate>
    <supported-rate name="wlan1">
      <rate>12</rate>
    </supported-rate>
#ifdef CONFIG_OAP_RADIO_2_MODE_DEFAULT_G
    <supported-rate name="wlan1">
      <rate>11</rate>
    </supported-rate>
#endif
    <supported-rate name="wlan1">
      <rate>9</rate>
    </supported-rate>
    <supported-rate name="wlan1">
      <rate>6</rate>
    </supported-rate>

#ifdef CONFIG_OAP_RADIO_2_MODE_DEFAULT_G
    <supported-rate name="wlan1">
      <rate>5.5</rate>
    </supported-rate>
    <supported-rate name="wlan1">
      <rate>2</rate>
    </supported-rate>
    <supported-rate name="wlan1">
      <rate>1</rate>
    </supported-rate>
#endif /* CONFIG_OAP_RADIO_2_MODE_DEFAULT_G */
#endif /* CONFIG_OAP_RADIOS_2 */

#ifdef CONFIG_OAP_QOS
  <tx-queue name="wlan0">
    <queue>data0</queue>
    <aifs>1</aifs>
    <cwmin>3</cwmin>
    <cwmax>7</cwmax>
    <burst>1.5</burst>
  </tx-queue>
  <tx-queue name="wlan0">
    <queue>data1</queue>
    <aifs>1</aifs>
    <cwmin>7</cwmin>
    <cwmax>15</cwmax>
    <burst>3.0</burst>
  </tx-queue>
  <tx-queue name="wlan0">
    <queue>data2</queue>
    <aifs>3</aifs>
    <cwmin>15</cwmin>
    <cwmax>63</cwmax>
    <burst>0</burst>
  </tx-queue>
  <tx-queue name="wlan0">
    <queue>data3</queue>
    <aifs>7</aifs>
    <cwmin>15</cwmin>
    <cwmax>1023</cwmax>
    <burst>0</burst>
  </tx-queue>

  <wme-queue name="wlan0">
    <queue>vo</queue>
    <aifs>2</aifs>
    <cwmin>3</cwmin>
    <cwmax>7</cwmax>
    <txop-limit>47</txop-limit>
    <acm>0</acm>
  </wme-queue>
  <wme-queue name="wlan0">
    <queue>vi</queue>
    <aifs>2</aifs>
    <cwmin>7</cwmin>
    <cwmax>15</cwmax>
    <txop-limit>94</txop-limit>
    <acm>0</acm>
  </wme-queue>
  <wme-queue name="wlan0">
    <queue>be</queue>
    <aifs>3</aifs>
    <cwmin>15</cwmin>
    <cwmax>1023</cwmax>
    <txop-limit>0</txop-limit>
    <acm>0</acm>
  </wme-queue>
  <wme-queue name="wlan0">
    <queue>bk</queue>
    <aifs>7</aifs>
    <cwmin>15</cwmin>
    <cwmax>1023</cwmax>
    <txop-limit>0</txop-limit>
    <acm>0</acm>
  </wme-queue>

#ifdef CONFIG_OAP_RADIOS_2
  <tx-queue name="wlan1">
    <queue>data0</queue>
    <aifs>1</aifs>
    <cwmin>3</cwmin>
    <cwmax>7</cwmax>
    <burst>1.5</burst>
  </tx-queue>
  <tx-queue name="wlan1">
    <queue>data1</queue>
    <aifs>1</aifs>
    <cwmin>7</cwmin>
    <cwmax>15</cwmax>
    <burst>3.0</burst>
  </tx-queue>
  <tx-queue name="wlan1">
    <queue>data2</queue>
    <aifs>3</aifs>
    <cwmin>15</cwmin>
    <cwmax>63</cwmax>
    <burst>0</burst>
  </tx-queue>
  <tx-queue name="wlan1">
    <queue>data3</queue>
    <aifs>7</aifs>
    <cwmin>15</cwmin>
    <cwmax>1023</cwmax>
    <burst>0</burst>
  </tx-queue>

  <wme-queue name="wlan1">
    <queue>vo</queue>
    <aifs>2</aifs>
    <cwmin>3</cwmin>
    <cwmax>7</cwmax>
    <txop-limit>47</txop-limit>
    <acm>0</acm>
  </wme-queue>
  <wme-queue name="wlan1">
    <queue>vi</queue>
    <aifs>2</aifs>
    <cwmin>7</cwmin>
    <cwmax>15</cwmax>
    <txop-limit>94</txop-limit>
    <acm>0</acm>
  </wme-queue>
  <wme-queue name="wlan1">
    <queue>be</queue>
    <aifs>3</aifs>
    <cwmin>15</cwmin>
    <cwmax>1023</cwmax>
    <txop-limit>0</txop-limit>
    <acm>0</acm>
  </wme-queue>
  <wme-queue name="wlan1">
    <queue>bk</queue>
    <aifs>7</aifs>
    <cwmin>15</cwmin>
    <cwmax>1023</cwmax>
    <txop-limit>0</txop-limit>
    <acm>0</acm>
  </wme-queue>
#endif /* CONFIG_OAP_RADIOS_2 */
#endif /* CONFIG_OAP_QOS */

#ifdef CONFIG_OAP_ORCHESTRATOR
  <cluster>
    <clustered>0</clustered>
    <clusterable>1</clusterable>
    <kickstarted>0</kickstarted>
    <locally-modified>0</locally-modified>
    <location>not set</location>
  </cluster>

  <channel-planner>
   <mode>none</mode>
   <energy_threshold>75</energy_threshold>
   <wlan_threshold>1000</wlan_threshold>
   <gather_interval></gather_interval>
   <plan_interval>60</plan_interval>
   <locked_aps>none</locked_aps>
   <bags>1-6-11,b,1, 6, 11|1-4-8-11,b,1, 4, 8, 11|A,a,36,40,44,48,52,56,60,149,153,157,161,165</bags>
   <current_bag>1-6-11</current_bag>
  </channel-planner>
#endif

#ifdef CONFIG_OAP_SNMP
  <snmp>
#ifdef CONFIG_OAP_SNMP_START_BY_DEFAULT
    <status>up</status>
#else
    <status>down</status>
#endif
    <ro-community>public</ro-community>
    <rw-community>system</rw-community>

	<!-- defines the source forr all SNMP requests - can be either default, a subnet, or a hostname. man snmpd.conf for more details -->
	<source-status>up</source-status>
	<source>default</source>

#ifdef CONFIG_OAP_SNMP_SET_ALLOWED_BY_DEFAULT
	<!-- SNMP-Set can be dynamically activated or deactivated through the web management interface -->
    <rw-status>up</rw-status>
#else
    <rw-status>down</rw-status>
#endif

  </snmp>
#endif

#ifdef CONFIG_OAP_CLI_ACCESS_SERIAL
  <serial>
#ifdef CONFIG_OAP_CLI_ACCESS_SERIAL_DEFAULT_ENABLED
    <status>up</status>
#else
    <status>down</status>
#endif
  </serial>
#endif

#ifdef CONFIG_OAP_CLI_ACCESS_SSH
  <ssh>
#ifdef CONFIG_OAP_CLI_ACCESS_SSH_DEFAULT_ENABLED
    <status>up</status>
#else
    <status>down</status>
#endif
  </ssh>
#endif

#ifdef CONFIG_OAP_CLI_ACCESS_TELNET
  <telnet>
#ifdef CONFIG_OAP_CLI_ACCESS_TELNET_DEFAULT_ENABLED
    <status>up</status>
#else
    <status>down</status>
#endif
  </telnet>
#endif

  <debug>
    <level>0</level>
    <klevel>2</klevel>
  </debug>

#ifdef CONFIG_OAP_PRODUCT_HANDLERS
#include "product-apconfig.xml.cpp"
#endif

</I802config>
