/* Copyright 2004 Instant802 Networks, Inc. All Rights Reserved. */

var security_modes = new Array('static-wep', 'dot1x', 'wpa-enterprise', 'wpa-personal');

var security_layers = new Array('static_wep_layer', 'one_x_layer', 'wpa_with_radius_layer', 'wpa_psk_layer');

/**
 * Cleans up the field names.
 * For the security mode selected, renames that layer's elements
 * to remove the layer prefix. 
 * The elements from non-selected modes will still have a layer
 * prefix, so they wont match any macros.
 */
function cleanupFieldNames(prefix) {
    var mode = document.forms[0].elements[prefix+'securityMode'].value;
    var modeNumber = -1;
    for (var i = 0; i < security_modes.length; i++) {
        if (mode == security_modes[i]) {
            modeNumber = i;
            break;
        }
    }
    if (modeNumber == -1) {
        return;
    }
    var re = new RegExp(prefix+security_layers[modeNumber]);

    for (var i = document.forms[0].elements.length; i > 0; i--) {
        var el = document.forms[0].elements[i-1];

        if (el.name.match(re)) {
            el.name = el.name.replace(re, prefix);
        }
    }
}

function isValidWpaPskPassPhraseCharacter(c)
{
    var code = c.charCodeAt(0);
    return code >= 32 && code <= 126;
}

function isValidWpaPskPassPhrase(s)
{
    if (! isStringLengthInRange(s, 8, 63)) {
        return false;
    }

    return isStringCharsInRange(s, 32, 126);
}

function getInvalidWpaPskPassPhraseReason(s)
{
    var msg = "";

    var lengthBad = false;
    if (! isStringLengthInRange(s, 8, 63)) {
        msg = msg 
            + getStringLengthNotInRangeReason(s, 8, 63);
        lengthBad = true;
    }

    if (! isStringCharsInRange(s, 32, 126)) {
        if (lengthBad) {
            msg = msg + ' ';
        }
        msg = msg
            + 'The following characters are not allowed: '
            + getStringCharsNotInRange(s, 32, 126)
            + '.';
    }
    return msg;
}

function validateStaticWepKey(keyIndex, transferKeyIndex, bytes, ascii, key) {
    if ((transferKeyIndex == keyIndex && ! isValidWepKey(key, bytes, ascii))
        || (transferKeyIndex != keyIndex && ! isValidWepKeyOrBlank(key, bytes, ascii))) {
        return "- Key "
            + keyIndex
            + " is invalid: "
            + getInvalidWepKeyReason(key, bytes, ascii)
            + "\n";
    } else {
        return "";
    }
}
