/**
 * apc_web_handler_input.h - Declarations for input macros.
 * Copyright: Copyright 2004 Instant802 Networks, Inc. All Rights Reserved.
 */

#ifndef APC_WEB_HANDLER_INPUT_DOT_H
#define APC_WEB_HANDLER_INPUT_DOT_H
#include "apc_web_types.h"

int apc_web_set_value_and_destroy(char *class, char *obj, apc_web_value_t *value);
apc_web_value_t *apc_web_get_cgi_up_down_value(char *property, char *macro);
apc_web_value_t *apc_web_get_cgi_value(char *property, char *macro);

int set_access_point_name(char *macro);

int set_actual_lan_ip_address(char *macro);

int set_actual_lan_netmask(char *macro);

int set_actual_radio_one_channel(char *macro);

int set_actual_radio_one_ssid(char *macro);

int set_actual_radio_two_channel(char *macro);

int set_actual_radio_two_ssid(char *macro);

int set_actual_wan_mac_address(char *macro);

int set_actual_wan_ip_address(char *macro);

int set_actual_wan_netmask(char *macro);

int set_admin_password(char *macro);

int set_associations_table(char *macro);

int set_configuration_file(char *macro);

int set_content_filter(char *macro);

int set_dhcp_nameserver_one_ip3(char *macro);

int set_dhcp_nameserver_two_ip3(char *macro);

int set_dhcp_server_enabled(char *macro);

int set_dhcp_server_end_ip3(char *macro);

int set_dhcp_server_lease_time(char *macro);

int set_dhcp_server_start_ip3(char *macro);

int set_dhcp_wins_ip3(char *macro);

int set_dns_one3(char *macro);

int set_dns_two3(char *macro);

int set_events_table(char *macro);

int set_firewall_enabled(char *macro);

int set_firmware_version(char *macro);

int set_gateway3(char *macro);

int set_lan_connection_type(char *macro);

int set_lan_ip3(char *macro);

int set_lan_mac_address(char *macro);

int set_lan_netmask3(char *macro);

int set_nat(char *macro);

int set_port_forward_eight_enabled(char *macro);

int set_port_forward_eight_external_port(char *macro);

int set_port_forward_eight_internal_ip3(char *macro);

int set_port_forward_eight_internal_port(char *macro);

int set_port_forward_eight_protocol(char *macro);

int set_port_forward_five_enabled(char *macro);

int set_port_forward_five_external_port(char *macro);

int set_port_forward_five_internal_ip3(char *macro);

int set_port_forward_five_internal_port(char *macro);

int set_port_forward_five_protocol(char *macro);

int set_port_forward_four_enabled(char *macro);

int set_port_forward_four_external_port(char *macro);

int set_port_forward_four_internal_ip3(char *macro);

int set_port_forward_four_internal_port(char *macro);

int set_port_forward_four_protocol(char *macro);

int set_port_forward_nine_enabled(char *macro);

int set_port_forward_nine_external_port(char *macro);

int set_port_forward_nine_internal_ip3(char *macro);

int set_port_forward_nine_internal_port(char *macro);

int set_port_forward_nine_protocol(char *macro);

int set_port_forward_one_enabled(char *macro);

int set_port_forward_one_external_port(char *macro);

int set_port_forward_one_internal_ip3(char *macro);

int set_port_forward_one_internal_port(char *macro);

int set_port_forward_one_protocol(char *macro);

int set_port_forward_seven_enabled(char *macro);

int set_port_forward_seven_external_port(char *macro);

int set_port_forward_seven_internal_ip3(char *macro);

int set_port_forward_seven_internal_port(char *macro);

int set_port_forward_seven_protocol(char *macro);

int set_port_forward_six_enabled(char *macro);

int set_port_forward_six_external_port(char *macro);

int set_port_forward_six_internal_ip3(char *macro);

int set_port_forward_six_internal_port(char *macro);

int set_port_forward_six_protocol(char *macro);

int set_port_forward_ten_enabled(char *macro);

int set_port_forward_ten_external_port(char *macro);

int set_port_forward_ten_internal_ip3(char *macro);

int set_port_forward_ten_internal_port(char *macro);

int set_port_forward_ten_protocol(char *macro);

int set_port_forward_three_enabled(char *macro);

int set_port_forward_three_external_port(char *macro);

int set_port_forward_three_internal_ip3(char *macro);

int set_port_forward_three_internal_port(char *macro);

int set_port_forward_three_protocol(char *macro);

int set_port_forward_two_enabled(char *macro);

int set_port_forward_two_external_port(char *macro);

int set_port_forward_two_internal_ip3(char *macro);

int set_port_forward_two_internal_port(char *macro);

int set_port_forward_two_protocol(char *macro);

int set_ppp_connect_on_demand(char *macro);

int set_ppp_domain_name(char *macro);

int set_ppp_host_name(char *macro);

int set_ppp_keepalive(char *macro);

int set_ppp_max_idle_time(char *macro);

int set_ppp_mode(char *macro);

int set_ppp_password(char *macro);

int set_ppp_redial_period(char *macro);

int set_ppp_username(char *macro);

int set_radio_one_channel(char *macro);

int set_radio_one_mode(char *macro);

int set_radio_two_channel(char *macro);

int set_radio_two_mode(char *macro);

int set_show_last_x_events(char *macro);

int set_show_last_x_urls(char *macro);

int set_txrx_table(char *macro);

int set_upnp_forward_eight_enabled(char *macro);

int set_upnp_forward_eight_external_port(char *macro);

int set_upnp_forward_eight_internal_ip3(char *macro);

int set_upnp_forward_eight_internal_port(char *macro);

int set_upnp_forward_eight_protocol(char *macro);

int set_upnp_forward_five_enabled(char *macro);

int set_upnp_forward_five_external_port(char *macro);

int set_upnp_forward_five_internal_ip3(char *macro);

int set_upnp_forward_five_internal_port(char *macro);

int set_upnp_forward_five_protocol(char *macro);

int set_upnp_forward_four_enabled(char *macro);

int set_upnp_forward_four_external_port(char *macro);

int set_upnp_forward_four_internal_ip3(char *macro);

int set_upnp_forward_four_internal_port(char *macro);

int set_upnp_forward_four_protocol(char *macro);

int set_upnp_forward_nine_enabled(char *macro);

int set_upnp_forward_nine_external_port(char *macro);

int set_upnp_forward_nine_internal_ip3(char *macro);

int set_upnp_forward_nine_internal_port(char *macro);

int set_upnp_forward_nine_protocol(char *macro);

int set_upnp_forward_one_enabled(char *macro);

int set_upnp_forward_one_external_port(char *macro);

int set_upnp_forward_one_internal_ip3(char *macro);

int set_upnp_forward_one_internal_port(char *macro);

int set_upnp_forward_one_protocol(char *macro);

int set_upnp_forward_seven_enabled(char *macro);

int set_upnp_forward_seven_external_port(char *macro);

int set_upnp_forward_seven_internal_ip3(char *macro);

int set_upnp_forward_seven_internal_port(char *macro);

int set_upnp_forward_seven_protocol(char *macro);

int set_upnp_forward_six_enabled(char *macro);

int set_upnp_forward_six_external_port(char *macro);

int set_upnp_forward_six_internal_ip3(char *macro);

int set_upnp_forward_six_internal_port(char *macro);

int set_upnp_forward_six_protocol(char *macro);

int set_upnp_forward_ten_enabled(char *macro);

int set_upnp_forward_ten_external_port(char *macro);

int set_upnp_forward_ten_internal_ip3(char *macro);

int set_upnp_forward_ten_internal_port(char *macro);

int set_upnp_forward_ten_protocol(char *macro);

int set_upnp_forward_three_enabled(char *macro);

int set_upnp_forward_three_external_port(char *macro);

int set_upnp_forward_three_internal_ip3(char *macro);

int set_upnp_forward_three_internal_port(char *macro);

int set_upnp_forward_three_protocol(char *macro);

int set_upnp_forward_two_enabled(char *macro);

int set_upnp_forward_two_external_port(char *macro);

int set_upnp_forward_two_internal_ip3(char *macro);

int set_upnp_forward_two_internal_port(char *macro);

int set_upnp_forward_two_protocol(char *macro);

int set_url_log_table(char *macro);

int set_wan_connection_type(char *macro);

int set_wan_ip3(char *macro);

int set_wan_mac_address5(char *macro);

int set_wan_netmask3(char *macro);

int set_snmp_enabled(char *macro);

int set_snmp_ro_community(char *macro);

int set_snmp_set_enabled(char *macro);

int set_snmp_rw_community(char *macro);

int set_snmp_source_enabled(char *macro);

int set_snmp_source(char *macro);

void apc_web_setup_input_handlers(apc_web_interface_t *interface);
#endif
