/*
 * Created on Aug 20, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.DataPath;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import com.instant802.cldc.deviceconfiguration.ConfigObject;
import com.instant802.cldc.deviceconfiguration.ObjectList;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class GenericRecord extends XMLRepresentation {

	public static final String FIELD_TRUE = "1";
	public static final String FIELD_FALSE = "0";
	private static String UNDEFINED_FIELD = "";
	private static Class rawXMLClass;
	protected Hashtable data;
	protected Vector keys; // To make sure we can serialize fields out IN ORDER

	/**
	 * initialize the rawXMLClass static member.
	 */
	static {
		try {
			rawXMLClass = Class.forName(AppendableAsXML.TYPE);
		} catch (ClassNotFoundException e) {
			emergency( e );
		}
	}

	public Hashtable asHashTable() {
		return data;
	}

	private static void emergency(ClassNotFoundException e) {
		Log.emergency("GenericRecord", e );
	}

	protected GenericRecord() {
		data = new Hashtable();
		keys = new Vector();
	}

	public abstract String typeName();

	protected void startTag(StringBuffer buffer) {
		openTag(buffer, typeName());
	}

	public void appendAsXML(StringBuffer buffer) {
		startTag(buffer);
		Enumeration k = keys.elements();
		while (k.hasMoreElements()) {
			String key = (String) k.nextElement();
			openTag(buffer, key);
			Object content = data.get(key);
			if( appendableAsXML( content ) ) {
				((AppendableAsXML) content).appendAsXML( buffer );
			} else {
				appendData(buffer, content.toString());
			}
			closeTag(buffer, key);
		}
		closeTag(buffer, typeName());
	}
	
	/**
	 * return true if the supplied object is capable of appending its content
	 * as XML to a stringbuffer
	 */
	private boolean appendableAsXML(Object content) {
		return rawXMLClass.isAssignableFrom( content.getClass() );
	}

	public final void field(String name, String value) {
		data.put(name, value);
		addKey(name);
	}

	protected final void mergeIn(GenericRecord record) {
		Hashtable table = record.asHashTable();
		Enumeration e = table.keys();
		while (e.hasMoreElements()) {
			String key = (String) e.nextElement();
			data.put(key, (String) table.get(key));
			addKey(key);
		}
	}

	protected final void field(String name, ObjectList list) {
		data.put(name, list);
		addKey(name);
	}
	
	private void addKey(String name) {
		if (! keys.contains(name))
			keys.addElement(name);
	}

	protected String field(String string) {
		String value = (String) data.get(string);
		return null != value ? value : UNDEFINED_FIELD;
	}

	protected final ObjectList objectsField(String field) {
		if (Log.DEBUG) debug("objectsfield: "+data.get(field) );
		return (ObjectList) data.get(field);
	}

	protected final boolean hasField(String field) {
		return data.containsKey(field);
	}

	protected void removeField(String field) {
		data.remove(field);
		keys.removeElement(field);
	}

	public final int intField(String string) {
		try {
			return Integer.parseInt(field(string));
		} catch (NumberFormatException e) {
			return 0;
		}
	}

	public String stringField(String string) {
		if (hasField(string))
			return data.get(string).toString();
		else
			return null;
	}
	
	protected Enumeration fieldNames() {
		return keys.elements();
	}

	protected final void intField(String string, int value) {
		field(string, "" + value);
	}

	public boolean booleanField(String name) {
		String field = field(name);
		if (null != field) {
			return field.trim().equals(ConfigObject.FIELD_TRUE);
		}
		return false;
	}

	public void booleanField(String name, boolean value) {
		if (value) {
			field(name, FIELD_TRUE);
		} else {
			field(name, FIELD_FALSE);
		}
	}

	protected void makeFromXMLRecord(XMLRecord record)
		throws XMLRepresentationException {
		checkType(record);
		this.data = record.asHashTable();
		this.keys = record.keys();
	}

	protected void checkType(XMLRecord record)
		throws XMLRepresentationException {
		if (!record.typeName().equals(this.typeName())) {
			throw new XMLRepresentationException(
				"could not convert received "
					+ record.typeName()
					+ " into "
					+ this.typeName());
		}
	}

	public String toString() {
		return typeName() + asHashTable().toString();
	}

	protected int size() {
		return data.size();
	}
}
