/*
 * Created on Aug 22, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.SessionMonitor;

import java.util.Enumeration;
import java.util.Vector;

import com.instant802.cldc.DataPath.NameValuePairFileReader;
import com.instant802.cldc.linuxfstools.DirectoryReader;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AssociationModel {

	private String radioMac;
	private final String interfacesDirectory = "/proc/net/ieee80211";
	
	public AssociationModel( String radioMac ) {
		this.radioMac = radioMac;
	}
	
	private AssociationRecord recordForStation(String staMac, String path ) {
		if (Log.DEBUG) Log.debug("recordforstation");
		NameValuePairFileReader reader = new NameValuePairFileReader( path );
		if (Log.DEBUG) Log.debug("creating association record");
		AssociationRecord record = new AssociationRecord( staMac, radioMac,  reader );
		if (Log.DEBUG) Log.debug("association record created");
		return record;
	}

	
	public Enumeration currentRecords() {
		if (Log.DEBUG) debug("currentRecords()");
		Vector stations = new Vector();
		if (Log.DEBUG) debug("reading interfaces");
		DirectoryReader interfaces = new DirectoryReader();
		interfaces.openDirectory( interfacesDirectory );
		String iface = interfaces.readDirectory();
		while( iface != null ) {
			if (Log.DEBUG) debug("interface = "+iface );
			if( ! interfaces.navReference( iface ) ) {
				String stationsDirectory = interfacesDirectory + "/" + iface+"/sta/";	
				if (Log.DEBUG) debug("stations directory is: "+stationsDirectory );
				readStations(stations, stationsDirectory);
			}
			iface = interfaces.readDirectory();
		}
		interfaces.closeDirectory();
		return stations.elements();
	}

	private void debug(String string) {
		Log.debug("AssociationModel", string );
	}

	private void readStations(Vector stations, String stationsDirectory) {
		DirectoryReader sta = new DirectoryReader();
			sta.openDirectory(stationsDirectory);
			String file = sta.readDirectory();
			while( file != null ) {
				if (Log.DEBUG) Log.info("file="+file);
				if( ! sta.navReference( file )) {
					String path = stationsDirectory + "/" + file;
					if (Log.DEBUG) Log.info("path is: "+path ); 
					stations.addElement( recordForStation( file, path ) );
				}
				file = sta.readDirectory();
			}
			sta.closeDirectory();
	}
}
