/*
 * Created on Aug 13, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.SessionMonitor;

import com.instant802.cldc.DataPath.GenericRecord;
import com.instant802.cldc.DataPath.NameValuePair;
import com.instant802.cldc.DataPath.NameValuePairFileReader;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AssociationRecord extends GenericRecord {

	private static final String INVALID_CHARS = " []";
	private static final String TYPE = "AssociationRecord";
	private static final String AP_MAC = "ap_mac";
	static final String STA_MAC = "sta_mac";
	static final String INACTIVE_MSEC = "inactive_msec";
	/**
	 * @param reader
	 */
	public AssociationRecord(
		String staMac,
		String apRadioMac,
		NameValuePairFileReader reader) {
		super();
		if (Log.DEBUG) debug("creating association record");
		if (Log.DEBUG) debug("adding mac addresses...");
		data.put( STA_MAC, staMac );
		if (Log.DEBUG) debug("station mac: "+staMac );
		data.put( AP_MAC, apRadioMac );
		if (Log.DEBUG) debug("radio mac: "+staMac );

		if (Log.DEBUG) debug("about to read elements from the pair reader");
		while( reader.hasMoreElements() ) {
			NameValuePair pair = (NameValuePair) reader.nextElement();
			if( pair != null ) {
				if (Log.DEBUG) debug( "read pair name="+pair.getName()+"  value="+pair.getValue() );
				if( valid( pair.getName() ) ) {
					data.put( pair.getName(), pair.getValue() );			
				}
			}
		}
	}

	/**
	 * return true if the string contains none of the invalid characters for
	 * a field name.
	 */
	private boolean valid(String string) {
		for( int i = 0; i < INVALID_CHARS.length(); i ++ ) {
			if( string.indexOf( INVALID_CHARS.charAt(i) ) > 0 ) {
				return false;
			}
		}
		return true;
	}

	public String staMac() {
		return (String) data.get( STA_MAC );
	}

	public String apRadioMac() {
		return (String) data.get( AP_MAC );
	}

	public int age() {
		//TODO: deal with the case where this is not set - because an exception is likely to be thrown.
		return Integer.parseInt((String) data.get( INACTIVE_MSEC ));
	}

	/**)
	 * @see com.instant802.cldc.DataPath.GenericRecord#typeName()
	 */
	public String typeName() {
		return TYPE;
	}
}
