/*
 * Created on Aug 13, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.SessionMonitor;

import java.util.Enumeration;
import java.util.Vector;

import com.instant802.cldc.Activation.Activator;
import com.instant802.cldc.Activation.InvocationMessage;
import com.instant802.cldc.Activation.InvocationResult;
import com.instant802.cldc.Activation.Service;
import com.instant802.cldc.Activation.ServiceInstanceManager;
import com.instant802.cldc.DataPath.GenericRecord;
import com.instant802.cldc.orchestrator.OrchestratorNode;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class LocalSessionMonitorImpl extends Service implements LocalSessionMonitor {

	private final OrchestratorNode node;

	public LocalSessionMonitorImpl( OrchestratorNode node ) {
		this.node = node;
	}

	private void debug( String message ) {
		Log.debug( "LocalSessionMonitorImpl", message );
	}
	
	public Enumeration getCurrentRecords() {
		Vector records = new Vector();
		Enumeration e = node.associations().currentRecords();
		if (Log.DEBUG) debug("reading association records");
		while( e.hasMoreElements() ) {
			AssociationRecord assocRecord = (AssociationRecord) e.nextElement();
			if (Log.DEBUG) debug("creating session record");
			SessionStatusRecord statusRecord = new SessionStatusRecord( node, assocRecord, node.authHistory() );
			if (Log.DEBUG) debug("adding session record");
			records.addElement( statusRecord );
		}
		if (Log.DEBUG) debug("returning records");
		return records.elements();
	}
	
	static class InstanceManager extends ServiceInstanceManager {

		/* (non-Javadoc)
		 * @see com.instant802.cldc.Activation.ServiceInstanceManager#typeName()
		 */
		protected String typeName() {
			return LocalSessionMonitor.TYPE;
		}

		/* (non-Javadoc)
		 * @see com.instant802.cldc.Activation.ServiceInstanceManager#getInstance(com.instant802.cldc.cluster.OrchestratorNode, com.instant802.cldc.Activation.Activator)
		 */
		public Service getInstance( String name, OrchestratorNode node, Activator a) throws Exception {
			LocalSessionMonitorImpl monitor = new LocalSessionMonitorImpl( node );
			a.addService( name, monitor );
			return monitor;
		}
	}

	/* (non-Javadoc)
	 * @see com.instant802.cldc.Activation.Service#doMethod(java.lang.String, com.instant802.cldc.Activation.InvocationMessage, com.instant802.cldc.Activation.InvocationResult)
	 */
	protected boolean doMethod(String name, InvocationMessage message, InvocationResult result) throws Exception {
		if( name.equals("get_current_records") ) {
			Enumeration e = getCurrentRecords();
			while( e.hasMoreElements() ) {
				result.add( (GenericRecord) e.nextElement() );
			}
			return true;
		}
		return false;
	}
}
