/*
 * Created on Aug 23, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.TestFramework;

import java.util.Enumeration;
import java.util.Vector;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class TestSuite {
	
	private Vector testCases = new Vector();
	
	/**
	 * add test cases to the suite.
	 */
	protected abstract void suite();
	
	protected void add( TestCase t ) {
		testCases.addElement( t );
	}

	public void  run( boolean fullsummary ) {
		suite();
		runTests();
		summarize( fullsummary );
		stats();
	}

	/**
	 * 
	 */
	private void stats() {
		Enumeration tests = testCases.elements();
		int total = 0;
		int passed = 0;
		int failed = 0;
		while( tests.hasMoreElements()) {
			TestCase c = (TestCase) tests.nextElement();
			total += c.getTotal();
			passed += c.getPassed();
			failed += c.getFailed();
		}
		log( "TESTS RUN: " + total+ "  PASSED: " +((passed * 100)/ total)+ 
			"%  ("+passed+")  FAILED: " +((failed * 100)/ total)+ "%  ("+failed +")" );
		log("");
	}

	/**
	 * 
	 */
	private void summarize( boolean full ) {
		Enumeration tests = testCases.elements();
		log("*** TEST RESULTS ***");
		while( tests.hasMoreElements()) {
			((TestCase) tests.nextElement()).summary( full );
		}	
	}

	/**
	 * 
	 */
	private void runTests() {
		log( "RUNNING TESTS..." );
		Enumeration tests = testCases.elements();
		while( tests.hasMoreElements()) {
			TestCase t = (TestCase) tests.nextElement();
			log( " RUNNING CASE: "+t.getName() );
			t.run();
		}
		log( "TEST RUN COMPLETE." );
		log("");
	}

	private void log(String string) {
		System.out.println( string );
	}
}
