/*
 * Created on Oct 29, 2003
 * author: Robin Barooah
 * (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.clustermastering;

import com.instant802.cldc.deviceconfiguration.ElementNotFoundException;
import com.instant802.cldc.net.SocketException;

/**
 * @author robin
 */
public interface ClusterMasterAgent {
	public abstract ClusterMaster getMaster()
		throws
			ElementNotFoundException,
			InvalidTimingException,
			SocketException,
			AgentNotRunningException;
	/**
	 * this method defines the behavior when a new master is announced.
	 */
	public abstract void handleMasterAnnouncement(AnnounceMasterMessage message)
		throws ElementNotFoundException, SocketException;
	public abstract void deactivate();
	public abstract void invalidateMaster() throws ElementNotFoundException, SocketException;
	public abstract void makeAnnouncement()  throws ElementNotFoundException, SocketException;
	public abstract void activate();
	public abstract void confirmMaster();
}