/*
 * Created on Oct 27, 2003
 * author: Robin Barooah
 * (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.coordination;

import java.io.IOException;

import com.instant802.cldc.DataPath.XMLRecord;
import com.instant802.cldc.DataPath.XMLRepresentationException;
import com.instant802.cldc.LSQL.APConfException;
import com.instant802.cldc.LSQL.LSQLException;
import com.instant802.cldc.clustermastering.AgentNotRunningException;
import com.instant802.cldc.clustermastering.InvalidTimingException;
import com.instant802.cldc.deviceconfiguration.ElementNotFoundException;
import com.instant802.cldc.messaging.Message;
import com.instant802.cldc.messaging.ReplyMechanism;
import com.instant802.cldc.net.MalformedHTTPMessageException;
import com.instant802.cldc.net.SocketException;
import com.instant802.cldc.orchestrator.OrchestratorNode;

/**
 * @author robin
 */
public class ProbeResponseMessage extends Message {

	public static final String TYPE = "ProbeResponseMessage";

	public ProbeResponseMessage(ReplyMechanism toReply, XMLRecord record)
		throws XMLRepresentationException {
			super( toReply, record );
	}

	public ProbeResponseMessage(OrchestratorNode node)
		throws ElementNotFoundException {
			super( node );
	}

	public void onReceipt(OrchestratorNode node)
		throws
			ElementNotFoundException,
			XMLRepresentationException,
			IOException,
			MalformedHTTPMessageException,
			LSQLException,
			APConfException,
			InvalidTimingException,
			SocketException,
			AgentNotRunningException {
				
				node.coordinationAgent().handleProbeResponse( this );
				
	}

	public String typeName() {
		return TYPE;
	}

}
