package com.instant802.cldc.coordination;

import java.util.Enumeration;
import java.util.Vector;
import com.instant802.cldc.util.Log;

public class SenderPool
{
	private final int maxThreads;
	private final Vector threads = new Vector();
	
	public SenderPool( int max ) {
		this.maxThreads = max;
	}
	
	public synchronized void awaitCompletion() {
		Enumeration e = threads.elements();
		while( e.hasMoreElements() ) {
			Thread t = (Thread) e.nextElement();
			try{
				t.join();
			} catch (InterruptedException e1) {
				Log.error( e1 );
			}
		}
	}
	
	public synchronized void add( Thread toAdd ) {
		threads.addElement( toAdd );
		while( countLiving() >= maxThreads )
			waitForSomeoneToDie();
	}
	
	void waitForSomeoneToDie() {
		Log.debug("waiting for a sender to die");
		if( threads.size() > 0 ) {
			Thread t = (Thread) threads.elementAt( 0 );
			threads.removeElementAt( 0 );
			try{
				t.join();
				t = null;
			} catch (InterruptedException e1) {
				Log.error( e1 );
			}
		}
		Log.debug("sender dead");
	}
	
	int countLiving() {
		Enumeration e = threads.elements();
		int count = 0;
		while( e.hasMoreElements() ) {
			Thread t = (Thread) e.nextElement();
			if( t.isAlive() )
				count ++;
		}
		Log.debug("senders living: "+count+" ");
		return count;
	}	
}
