/*
 * Created on Oct 5, 2003
 * written by robin
 * (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.deviceconfiguration;

import java.util.Vector;

import com.instant802.cldc.clustermembership.ClusterMember;

/**
 * @author robin
 */
public class ClusteredAP extends ConfigObjectAdapter {

	public static final String TYPE = "cluster-member";
	public static final PrimaryKey PK = Schema.PK_IS_NAME_ATTRIBUTE;	
	public static final String LOCATION = "location";
	public static final String MAC = "mac";
	public static final String IP = "ip";
	public static final String ENABLED = "enabled";
	public static final String REMOVED = "removed";
	public static final String RADIO_MACS = "radio_macs";	
	public static final String[] SHARED_FIELDS = new String[] { LOCATION , MAC, IP, ENABLED, REMOVED, RADIO_MACS }; 
	
	public ClusteredAP( ConfigObject object ) {
		super( object );
	}
	
	public ClusteredAP(Schema schema, ClusterMember member ) {
		super( new ConfigObject( schema ) );
		setType( TYPE );
		setNameAttribute( member.id() );
		field( MAC, member.id() );
		field( IP, member.ipAddress() );
		booleanField( ENABLED, true );
		booleanField( REMOVED, false );
		field( LOCATION, member.location() );
		field( RADIO_MACS,  member.radioMacs());
	}
		
	private void setType(String type ) {
		getObject().setType( type );
	}

	public String location() {
		return field( LOCATION );
	}
		
	public String id() {
		return field( MAC );
	}

	public String ipAddress() {
		return field( IP );
	}

	public void ipAddress(String string) {
		field( IP, string );
	}

	public boolean isMarkedForRemoval() {
		return booleanField( REMOVED );
	}

	public void location(String location) {
		field( LOCATION , location );
	}

	public String macAddress() {
		return field(MAC);
	}
	
	public String radioMacs()
	{
		return field(RADIO_MACS);
	}
}
