/*
 * Created on Nov 2, 2003
 * author: Robin Barooah
 * (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.deviceconfiguration;

import java.util.Enumeration;

import com.instant802.cldc.util.Log;

/**
 * @author robin
 */
class ConfigObjectAdapter {

	protected String UNDEFINED_FIELD = ConfigObject.UNDEFINED_FIELD;
	private final ConfigObject object;
	
	ConfigObjectAdapter( ConfigObject object ) {
		// TODO: perhaps we should check the type of the object here and
		// throw an exception if not correct?
		this.object = object;
	}

	public void dump() {
		Enumeration e = object.fieldNames();
		while( e.hasMoreElements() ) {
			String name = (String) e.nextElement();
			String value = field( name );
			Log.info( object.typeName()+": "+name+"="+value );
		}
	}
	
	protected String field( String name ) {
		return object.field( name );
	}

	protected void field( String name, String value ) {
		object.field( name, value );
	}

	protected boolean booleanField( String name ) { 
		return object.booleanField( name );
	}

	protected void booleanField( String name, boolean value ) {
		object.booleanField( name, value );
	}
	
	protected int intField( String name ) {
		return object.intField( name );
	}
	
	protected void setNameAttribute( String name ) {
		object.setNameAttribute( name );
	}
	
	protected String getNameAttribute() {
		return object.getNameAttribute();
	}
	
	ConfigObject getObject() { 
		return object;
	}
}
