/*
 * Created on Oct 3, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.deviceconfiguration;

import java.util.Enumeration;
import java.util.Vector;

import com.instant802.cldc.LSQL.APConfException;
import com.instant802.cldc.LSQL.LSQLException;
import com.instant802.cldc.orchestrator.OrchestratorNode;
import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ConfigurationChanges {

	private final OrchestratorNode node;
	private final Vector additions = new Vector();
	private final Vector deletions = new Vector();
	private final Vector updates = new Vector();

	ConfigurationChanges( OrchestratorNode node ) {
		this.node = node;
	}
	
    private boolean filter(ConfigObject o ) {
	return node.schema().filter( o );
    }

    private void amend( FieldChanges2 changes ) {
	    node.schema().amend( changes );
    }
    
	/**
	 * apply the current set of changes to APConfD
	 */
	public synchronized void apply( MutableConfiguration configuration ) throws LSQLException, APConfException {
		if (Log.DEBUG) debug("applying deletions");
		applyDeletions( configuration );
		if (Log.DEBUG) debug("applying additions");
		applyAdditions( configuration );
		if (Log.DEBUG) debug("applying updates");
		applyUpdates( configuration );
		if (Log.DEBUG) debug("'setting running config'");
	}

	private void debug(String string) {
		Log.debug("ConfigurationChanges", string );
	}

	private void applyDeletions(MutableConfiguration configuration) throws APConfException {
		Enumeration deletion = deletions.elements();
		while( deletion.hasMoreElements() ) {
			try {
				configuration.deleteObject( (ConfigObject) deletion.nextElement() );
			} catch (LSQLException e) {
				handleLSQLException( e );
			}
		}
	}

	private void handleLSQLException(LSQLException e) {
	//	node.nodeStatusRecord().setClusterFailureStatus( e.getMessage() );
	}

	private void applyAdditions(MutableConfiguration configuration) throws APConfException {
		Enumeration addition = additions.elements();
		while( addition.hasMoreElements() ) {
			try {
				configuration.addObject( (ConfigObject) addition.nextElement() );
			} catch (LSQLException e) {
				handleLSQLException( e );
			}
		}
	}

	private void applyUpdates(MutableConfiguration configuration) throws APConfException {
		Enumeration update = updates.elements();
		while( update.hasMoreElements() ) {
			FieldChanges2 object = (FieldChanges2) update.nextElement();
			if (Log.DEBUG) debug("asking client to update "+object );
			try {
				configuration.updateObject( object );
			} catch (LSQLException e) {
				handleLSQLException( e );
			}
			if (Log.DEBUG) debug("update done");
		}
	}

	/**
	 * @param candidate
	 */
	public synchronized void delete(ConfigObject candidate) {
	    if( ! filter( candidate ) ) {
		if (Log.DEBUG) debug("deleting "+candidate.typeName() );
		deletions.addElement( candidate );
	    }
	}
	
	/**
	 * @param desiredState
	 */
	public synchronized void update(FieldChanges2 desiredState) {
	    if( ! filter( desiredState.object() ) ) {
		if (Log.DEBUG) debug("updating "+desiredState.typeName());
		updates.addElement( desiredState );
	    }
	}

	/**
	 * @param candidate
	 */
	public synchronized void add(ConfigObject candidate) {
	    if( ! filter( candidate ) ) {
		if (Log.DEBUG) debug("adding " + candidate.typeName() );
		additions.addElement( candidate );
	    }
	}
}
