/*
 * Created on Oct 2, 2003
 * 
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.deviceconfiguration;
import com.instant802.cldc.util.Log;

import java.util.Hashtable;

/**
 * @author robin
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Schema
{

	private static final String OBJECT_INTERFACE = "interface";
	private static final String OBJECT_PORTAL = "portal";
	private static final String OBJECT_DHCP_CLIENT = "dhcp-client";
	private static final String OBJECT_NTP = "ntp";
	private static final String OBJECT_BASIC_RATE = "basic-rate";
	private static final String OBJECT_SUPPORTED_RATE = "supported-rate";
	private static final String OBJECT_TX_QUEUE = "tx-queue";
	private static final String OBJECT_RADIO = "radio";
	private static final String OBJECT_BSS = "bss";
	private static final String OBJECT_MAC_ACL = "mac-acl";
	private static final String OBJECT_LOG = "log";
	private static final String OBJECT_CHANNEL_PLANNER = "channel-planner";
	private static final String OBJECT_INTERFACE_TYPE = "type";
	private static final String BSS_STATUS = "status";
	private static final String VLAN= "vlan";
	private static final String BRIDGE = "bridge";
	private static final String VWN_NAME = "vwn";
	public static final PrimaryKey PK_IS_NAME_ATTRIBUTE = new PKNameAttribute();

	private final Hashtable shared = new Hashtable();
	private final Hashtable primaryKeys = new Hashtable();
	private final Hashtable writeLocal = new Hashtable();

	public Schema()
	{

		// Host
		primaryKeys.put( SystemConfig.TYPE, SystemConfig.PK );
		shared.put( SystemConfig.TYPE, SystemConfig.SHARED_FIELDS );

		// Clustered AP
		primaryKeys.put(ClusteredAP.TYPE, ClusteredAP.PK);
		shared.put(ClusteredAP.TYPE, ClusteredAP.SHARED_FIELDS);

		// Wireless User
		primaryKeys.put(WirelessUser.TYPE, WirelessUser.PK);
		shared.put(WirelessUser.TYPE, WirelessUser.SHARED_FIELDS);

		// Interface
		primaryKeys.put(OBJECT_INTERFACE, PK_IS_NAME_ATTRIBUTE);
		shared.put(
			OBJECT_INTERFACE,
			new String[] {
				"ssid",
				"fd",
				"hello",
				"type",
				"radio",
				"bss",
				"wep-key-length",
				"security",
				"wep-default-key",
				"wpa-personal-key",
				"wep_key-ascii",
				"wep-key-1",
				"wep-key-2",
				"wep-key-3",
				"wep-key-4" });

		// Portal
		primaryKeys.put( OBJECT_PORTAL, new PKSingleton( OBJECT_PORTAL ) );
		shared.put( OBJECT_PORTAL, new String[] { "welcome-screen", "welcome-screen-text" } );

//		// DHCP Client
//		primaryKeys.put( OBJECT_DHCP_CLIENT, new PKSingleton( OBJECT_DHCP_CLIENT ) );
//		shared.put( OBJECT_DHCP_CLIENT, new String[] { "status", "interface" } );

		// NTP
		primaryKeys.put( OBJECT_NTP, new PKSingleton( OBJECT_NTP ) );
		shared.put( OBJECT_NTP, new String[] { "status", "server" } );

		// Basic Rate
		primaryKeys.put(OBJECT_BASIC_RATE, new PKField("rate"));
		shared.put(OBJECT_BASIC_RATE, new String[] { "rate" });

		// Supported Rate
		primaryKeys.put(OBJECT_SUPPORTED_RATE, new PKField("rate"));
		shared.put(OBJECT_SUPPORTED_RATE, new String[] { "rate" });

		// TX Queue
		primaryKeys.put(OBJECT_TX_QUEUE, new PKFieldAndNameAttribute("queue"));
		shared.put(
			OBJECT_TX_QUEUE,
			new String[] {
				"queue",
				"data",
				"aifs",
				"cwmin",
				"cwmax",
				"burst" });

		// Radio
		primaryKeys.put(OBJECT_RADIO, PK_IS_NAME_ATTRIBUTE);
		shared.put(
			OBJECT_RADIO,
			new String[] {
				"status",
				"max-bss",
				"channel-policy",
				"static-channel",
				"mode",
				"fragmentation-threshold",
				"rts-threshold",
				"ap-detection" });

		// BSS
		primaryKeys.put(OBJECT_BSS, PK_IS_NAME_ATTRIBUTE);
		shared.put(
			OBJECT_BSS,
			new String[] {
				"status",
				"radio",
				"beacon-interface",
				"ignore-broadcast-ssid",
				"mac-acl-mode",
				"mac-acl",
				"radius-ip",
				"radius-key",
				"radius-accounting",
				"open-system-authentication",
				"shared-key-authentication",
				"wpa-allow-non-wpa-stations",
				"wpa-cipher-tkip",
				"wpa-cipher-ccmp" });

		// MAC ACL
		primaryKeys.put(OBJECT_MAC_ACL, new PKField("mac"));
		shared.put(OBJECT_MAC_ACL, new String[] { "mac" });

		// Channel Planner
		primaryKeys.put(
			OBJECT_CHANNEL_PLANNER,
			new PKSingleton(OBJECT_CHANNEL_PLANNER));
		shared.put(
			OBJECT_CHANNEL_PLANNER,
			new String[] {
				"mode",
				"energy_threshold",
				"wlan_threshold",
				"locked_aps",
				"gather_interval",
				"plan_interval",
				"bags",
				"current_bag"});

		// Locally Persisted Fields
		writeLocal.put(
			OrchestratorConfig.TYPE,
			OrchestratorConfig.PERSISTED_FIELDS);
		shared.put(OrchestratorConfig.TYPE, OrchestratorConfig.SHARED_FIELDS);

		primaryKeys.put(OrchestratorConfig.TYPE, OrchestratorConfig.PK);
		primaryKeys.put(DebugConfig.TYPE, DebugConfig.PK);

		// "log"
		primaryKeys.put( OBJECT_LOG, new PKSingleton( OBJECT_LOG ) );
		shared.put( OBJECT_LOG, new String[] { "relay-enabled",
						       "relay-host",
						       "relay-port"} );
	}

	public boolean isShared(String typeName, String fieldName)
	{
		return findInTable(shared, typeName, fieldName);
	}

	public boolean isShared(String typeName) {
		return shared.containsKey(typeName);
	}
	
	private boolean findInTable(
		Hashtable table,
		String typeName,
		String fieldName)
	{
		synchronized (table)
		{
			String[] fields = (String[]) table.get(typeName);
			if (null == fields)
				return false;
			return inArray(fields, fieldName);
		}
	}

	private boolean inArray(String[] fields, String fieldName)
	{
		for (int i = 0; i < fields.length; i++)
		{
			if (fields[i].equals(fieldName))
			{
				return true;
			}
		}
		return false;
	}

	public boolean removeSharedField(String objectname, String fieldname)
	{
		String sharedfields[] = (String[]) shared.get(objectname);
		if (null == sharedfields)
			return false;
		String newsharedfields[] = new String[sharedfields.length - 1];
		for (int i = 0, j = 0; i < sharedfields.length; ++i)
		{
			if (j >= sharedfields.length - 1)
				return false; // couldn't find field to remove
			if (sharedfields[i].equals(fieldname))
				continue;
			newsharedfields[j] = sharedfields[i];
			++j;
		}
		shared.put(objectname, newsharedfields);
		return true;
	}

	public boolean addSharedField(String objectname, String fieldname)
	{
		String sharedfields[] = (String[]) shared.get(objectname);
		if (null == sharedfields)
			return false;
		String newsharedfields[] = new String[sharedfields.length + 1];
		for (int i = 0; i < sharedfields.length; ++i)
		{
			if (sharedfields[i].equals(fieldname))
				return true; // already in
			newsharedfields[i] = sharedfields[i];
		}
		newsharedfields[sharedfields.length] = fieldname;
		shared.put(objectname, newsharedfields);
		return true;
	}

	/**
	 * determine whether a configuration object is shared by checking whether
	 * it has any shared fields.
	 * 
	 * @param object
	 *                  the object to examine
	 * @return true if at least one field of the object is shared.
	 */
	public boolean isShared(ConfigObject object)
	{
		String[] sharedFields = (String[]) shared.get(object.typeName());
		if (null == sharedFields)
		{
			return false;
		} else
		{
			return sharedFields.length > 0;
		}
	}

	//	private boolean isSingleton(String typename) {
	//		String key = (String) primaryKeys.get( typename );
	//		if( null != key ) {
	//			if( key.equals( PK_IS_TYPENAME )) {
	//				return true;
	//			}
	//		}
	//		return false;
	//	}

	public boolean primaryKeyIsName(String typename)
	{
		String key = (String) primaryKeys.get(typename);
		if (null != key)
		{
			if (key.equals(PK_IS_NAME_ATTRIBUTE))
			{
				return true;
			}
		}
		return false;
	}

	public boolean writeLocally(ConfigObject candidate)
	{
		return candidate.typeName().equals(OrchestratorConfig.TYPE)
			|| isShared(candidate);
	}

	public boolean writeLocally(String typeName, String fieldName)
	{
		return findInTable(writeLocal, typeName, fieldName);
	}

	public boolean hasPrimaryKey(String typename)
	{
		return null != primaryKeys.get(typename);
	}

	public PrimaryKey getPrimaryKey(HasPrimaryKey object)
	{
		PrimaryKey key = (PrimaryKey) primaryKeys.get(object.typeName());
		if (null == key)
		{
			key = new PKNone(object);
		}
		return key;
	}

    /**
     * Determines whether changes pertaining to a specific object should be filtered out of the change set.
     * The argument o is the object that should be examined.  The method returns true if the 
     * change should be filtered out of the set.
     *
     * @param o the object to consider
     * @return true if changes to the object should be filtered out of the change set.
     * @author Robin Barooah
     */
    boolean filter( ConfigObject o ) {
	String type = o.typeName();
	if( type.equals( OBJECT_INTERFACE ) ) {
	    String itype = o.field( OBJECT_INTERFACE_TYPE );
	    Log.debug("Schema", "filtering "+type+"  with type="+itype );
	    if( itype.equals( VLAN ) ) {
		Log.debug("Schema","filtering vlan object out of change set");
		return true;
	    }
	    if( itype.equals( BRIDGE ) ) {
		    Log.debug("Schema", "filtering bridge object out of change set");
		    return true;
	    }
	}
	return false;
    }
    
    void amend( FieldChanges2 changes ) {
	    ConfigObject o = changes.object();
	    String type = o.typeName();
	    // select objects of type BSS..
	    if( type.equals( OBJECT_BSS ) ) {
		    String bssName = o.getNameAttribute();
		    // with name containing the vwn text...
		    if( bssName.indexOf( VWN_NAME ) > 0 )
		    {
			    // remove the status element from the set of fields to sync.
			    changes.removeField( BSS_STATUS );
		    }
	    }
    }
}
