/*
 * Created on Sep 16, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.net;

import java.util.Enumeration;
import java.util.Hashtable;

import com.instant802.cldc.util.Log;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class HTTPRequest extends HTTPMessage {

	private static final int DEFAULT_PORT = 80;
	private static final String METHOD_GET = "GET";
	private static final String HEADER_HOST = "Host";
	private static final  String HTTP_Version = "HTTP/1.1";
	private final String uri;
	private final String method;
	private final Hashtable headers = new Hashtable();
	private final String[] requiredHeaders = { HEADER_HOST };
	

	public HTTPRequest( String uri ) {
		method = METHOD_GET;
		this.uri = uri;
	}

	public void setHost( String host ) {
		headers.put( HEADER_HOST, host );
	}

	public StringBuffer getMessage() throws MalformedHTTPMessageException {
		checkHeaders();
		StringBuffer message = new StringBuffer();
		appendRequestLine( message );
		appendHeaders( message );
		message.append( CRLF );
		// this is where the body would be appended if there were one.
		if (Log.DEBUG) debug("message is : "+message );
		return message;
	}

	private void debug( String message ) {
		Log.debug("HTTPRequest" + message );
	}

	private void checkHeaders() throws MalformedHTTPMessageException {
		for( int i = 0; i < requiredHeaders.length; i++ ) {
			String value = (String) headers.get( requiredHeaders[ i ] );
			if( null == value ) NullHeader( value );
		}
	}

	private void appendHeaders(StringBuffer message) throws MalformedHTTPMessageException {
		Enumeration e = headers.keys();
		while( e.hasMoreElements() ) {
			String key = (String) e.nextElement();
			String value = (String) headers.get( key );
			if( value == null ) {
				NullHeader(key);
			}
			message.append( key ).append( ": " ).append( value ).append( CRLF );
		}
	}

	private void NullHeader(String key) throws MalformedHTTPMessageException {
		throw new MalformedHTTPMessageException( "header "+key+" is null" );
	}

	private void appendRequestLine(StringBuffer message) {
		message.append( method ).append( " " ).append( uri ).append(" ").append( HTTP_Version ).append( CRLF );
	}

	public String getHost() throws MalformedHTTPMessageException {
		String host = (String) headers.get( HEADER_HOST );
		if( null == host ) throw new MalformedHTTPMessageException("host header not set");
		return host;
	}

	public String getPort() {
		return ""+DEFAULT_PORT;
	}
}
