/*
 * Created on Aug 25, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.instant802.cldc.net;

import com.instant802.cldc.util.DateUtil;

/**
 * @author robin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ServerSocket extends SocketBase {
	
	int CONNECTION_BACKLOG = 5;
	int port = 0;
	
	public ServerSocket() throws SocketException {
		construct();
	}
	
	public void listen(int port) throws SocketException {
		try{
			checkOpen();
			int err = nativeBind(sd, port);
			if (err != 0) {
				close();
				throw new SocketException("couldn't bind to port: " + port);
			}
			err = nativeListen(sd, CONNECTION_BACKLOG);
			if (err != 0) {
				close();
				throw new SocketException(
						"couldn't start listening on port: " + port);
			}
			this.port = port;
		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
		}
	}
	
	public Socket accept() throws SocketException, SocketTimeoutException {
		try{
			if (port == 0) {
				throw new SocketException("cannot accept before listening on a port");
			}
			
			checkOpen();
			
			int res = nativeAccept(sd, timeout);
			
			if (res < 0) {
				if (isEINTR(res)) {
					throw new SocketTimeoutException("timed out waiting for accept");
				} else {
					throw new SocketException("error attempting to accept connections");
				}
			}
			return new Socket(res);
		} catch ( NullPointerException e ) {
			exitOnNullPointer( e );
			return null;
		}
	}
}
