/*
 * Created on Nov 10, 2003
 * 
 * To change the template for this generated file go to Window - Preferences -
 * Java - Code Generation - Code and Comments
 */
package com.instant802.cldc.radius;

import java.io.IOException;
import java.util.Hashtable;
import java.util.Enumeration;

import com.instant802.cldc.util.Log;
import com.instant802.cldc.util.QueueClosedException;

/**
 * @author alan
 * 
 * Since this RS is embedded it only has one radius client (The AP) and this TM
 * is trivial. __This current TM will not support the use of the RS as an
 * external radisu server__ (a key consisting of client+id would have to be
 * passed through the handler and returned)
 */
public class RadiusTransactionManager extends Thread
{
	private Hashtable nasTable;

	public RadiusTransactionManager()
	{
		nasTable = new Hashtable();
	}

	/**
	 * If this is a duplicate packet drop it and return false else create state
	 * to track the Radius transaction
	 */
	public synchronized boolean transactionStart(RadiusPacket rp)
	{
		Object key = makeKey(rp);

		if (nasTable.containsKey(key))
			return false;
		nasTable.put(key, new RadiusTransactionState(rp));
		return true;
	}

	public synchronized void transactionEnd(RadiusPacket rp) throws IOException
	{
		Object key = makeKey(rp);
		RadiusTransactionState state =
			(RadiusTransactionState) nasTable.get(key);
		if (state != null)
		{
			state.updatePacketAddress(rp.getDatagram());
			try {
				Proxy.sendQueue.enqueue(rp.getDatagram());
			} catch (QueueClosedException e) {
				Log.error("RadiusTransactionManager", e );
			}
			nasTable.remove(key);
		} else
		{
			if (Log.DEBUG) Log.info("Proxy: Forwarding state failure: id = " + rp.getCode());
		}
	}

	private Object makeKey(RadiusPacket rp)
	{
		return new Integer(rp.getIdentifier());
	}

	public void run()
	{
		while (true)
		{
			Enumeration keys = nasTable.keys();
			long currtime = System.currentTimeMillis();

			synchronized (this)
			{
				while (keys.hasMoreElements())
				{
					Object key = keys.nextElement();
					RadiusTransactionState state =
						(RadiusTransactionState) nasTable.get(key);
					if (currtime - state.getTime() > 1000L)
					{
						nasTable.remove(key);
					}
				}
			}
			try
			{
				Thread.sleep(1000L);
			} catch (Exception _)
			{
			}
		}
	}
}
