/*
 * Created on Apr 18, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package com.instant802.cldc.radius;

/**
 * @author alan
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class Utils
{

	private final static char[] hexm =
		{ '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };

	public static String hex(byte[] buf)
	{
		return hex(buf, buf.length);
	}

	public static String hex(byte[] buf, int buflength) {
		return hex(buf, 0, buflength);
	}
	
	public static String hex(byte[] buf, int off, int buflength)
	{
		return hex(buf, off, buflength, true);
	}

	public static String plainHex(byte[] buf)
	{
		return hex(buf, 0, buf.length, false);
	}
	
	public static String hex(byte[] buf, int off, int buflength, boolean colon)
	{
		StringBuffer sb = new StringBuffer();

		for (int i = 0; i < buflength; ++i)
		{
			int nib;
			nib = buf[i + off];

			sb.append(hexm[0xf & (nib >> 4)]);
			sb.append(hexm[nib & 0xf]);
			if (colon)
				sb.append(":");
		}
		return sb.toString();
	}
	
	public static String hexstr(byte[] buf, int buflength)
	{
		StringBuffer sb = new StringBuffer();

		for (int i = 0; i < buflength; ++i)
		{
			int nib;
			nib = buf[i];

			sb.append(hexm[0xf & (nib >> 4)]);
			sb.append(hexm[nib & 0xf]);
		}
		return sb.toString();
	}	

	public static byte[] padToMod16(byte[] buf, byte pad)
	{
		int chunks = 1 + (buf.length / 16);
		byte[] padbuf = new byte[16 * chunks];

		System.arraycopy(buf, 0, padbuf, 0, buf.length);
		for (int i = buf.length; i < padbuf.length; ++i)
		{
			padbuf[i] = pad;
		}
		return padbuf;
	}

	public static boolean compareBytes(byte[] b1, byte[] b2)
	{
		return compareBytes(b1, 0, b2, 0);
	}

	public static boolean compareBytes(byte[] b1, int o1, byte[] b2, int o2)
	{
		if ((b1.length - o1) != (b2.length - o2))
			return false;

		for (int i = 0; i < (b1.length - o1); ++i)
		{
			if (b1[o1 + i] != b2[o2 + i])
				return false;
		}
		return true;
	}

	public static boolean compareBytes(byte[] b1, int o1, byte[] b2, int o2, int len)
	{
		if ( (b1.length < (o1 + len)) || (b2.length < (o2 + len)))
			return false;

		for (int i = 0; i < len; ++i)
		{
			if (b1[o1 + i] != b2[o2 + i])
				return false;
		}
		return true;
	}
}
