/*
 * Created on Oct 6, 2003
 * written by robin
 * (C) 2003 Instant802 Networks Inc
 */
package com.instant802.cldc.util;

import java.util.Hashtable;

/**
 * @author robin
 */
public class ThreadCounter {
	
	private static final Hashtable table = new Hashtable();
	
	private static int count = 0;
	
	static synchronized String nextId() {
		return ""+count++;
	}

	public static synchronized void register( Thread thread ) {
		Integer key = makeKey(thread);
		if (Log.DEBUG) debug("registering thread "+ key );
		table.put( key, nextId() ); 
	}

	private static void debug(String string) {
		if (Log.DEBUG) Log.debug("ThreadCounter", string );
	}

	public static synchronized void deregister( Thread thread ){
		Integer key = makeKey( thread );
		table.remove( key );
	}

	private static Integer makeKey(Thread thread) {
		int hashCode = thread.hashCode();
		Integer key = new Integer( hashCode );
		return key;
	}

	public static synchronized String getId( Thread thread ) {
		Integer key = makeKey( thread );
		return ((String) table.get( key )) + "," + key.toString();
	}

	/**
	 * return the total number
	 * of threads registered ever in this VM instance.
	 */
	public static int getThreadsUsed() {
		return count;
	}
}
